using System;
using System.Text.Json.Serialization;
namespace org.isda.cdm {
   using concerto;
   class AdjustableDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableDates";
      public string id { get; set; }
      public DateTime[] unadjustedDate { get; set; }
      public DateTime[] adjustedDate { get; set; }
      public BusinessDayAdjustments dateAdjustments { get; set; }
   }
   class AdjustableDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableDatesBuilder";
      public string id { get; set; }
      public DateTime[] unadjustedDate { get; set; }
      public DateTime[] adjustedDate { get; set; }
   }
   class AmountSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AmountSchedule";
      public string[] currency { get; set; }
      public string currencyScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
      public Step[] step { get; set; }
   }
   class AmountScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AmountScheduleBuilder";
      public string[] currency { get; set; }
      public string currencyScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   class NonNegativeStep : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeStep";
      public string id { get; set; }
      public DateTime stepDate { get; set; }
      public float stepValue { get; set; }
   }
   class NonNegativeStepBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeStepBuilder";
      public string id { get; set; }
      public DateTime stepDate { get; set; }
      public float stepValue { get; set; }
   }
   class ComputedAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ComputedAmount";
      public string currency { get; set; }
      public string callFunction { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class ComputedAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ComputedAmountBuilder";
      public string currency { get; set; }
      public string callFunction { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class InterestShortFall : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestShortFall";
      public InterestShortfallCapEnum interestShortfallCap { get; set; }
      public bool compounding { get; set; }
      public FloatingRateIndexEnum rateSource { get; set; }
   }
   class InterestShortFallBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestShortFallBuilder";
      public InterestShortfallCapEnum interestShortfallCap { get; set; }
      public bool compounding { get; set; }
      public FloatingRateIndexEnum rateSource { get; set; }
   }
   class TradeHeaderBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TradeHeaderBuilder";
      public DateTime tradeDate { get; set; }
   }
   class TradeHeader : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TradeHeader";
      public PartyContractIdentifier[] identifier { get; set; }
      public DateTime tradeDate { get; set; }
   }
   class PaymentDetail : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDetail";
      public string id { get; set; }
      public AdjustableOrAdjustedDate paymentDate { get; set; }
      public PaymentRule paymentRule { get; set; }
      public Money paymentAmount { get; set; }
   }
   class PaymentDetailBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDetailBuilder";
      public string id { get; set; }
   }
   class PaymentRule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentRule";
      public PercentageRule percentageRule { get; set; }
   }
   class PaymentRuleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentRuleBuilder";
   }
   class AllocationOutcome : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AllocationOutcome";
      public ExecutionReference execution { get; set; }
      public ContractReference[] contractReference { get; set; }
      public Contract[] contract { get; set; }
   }
   class AllocationOutcomeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AllocationOutcomeBuilder";
   }
   class Account : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Account";
      public string id { get; set; }
      public string accountNumber { get; set; }
      public string accountName { get; set; }
      public AccountTypeEnum accountType { get; set; }
      public string accountBeneficiary { get; set; }
      public string servicingParty { get; set; }
      public string accountNameScheme { get; set; }
      public string accountNumberScheme { get; set; }
      public string accountTypeScheme { get; set; }
   }
   class AccountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AccountBuilder";
      public string id { get; set; }
      public string accountNumber { get; set; }
      public string accountName { get; set; }
      public AccountTypeEnum accountType { get; set; }
      public string accountBeneficiary { get; set; }
      public string servicingParty { get; set; }
      public string accountNameScheme { get; set; }
      public string accountNumberScheme { get; set; }
      public string accountTypeScheme { get; set; }
   }
   enum ContractualDefinitionsEnum {
      ISDA1991,
      ISDA_1993_COMMODITY,
      ISDA_1996_EQUITY,
      ISDA_1997_BULLION,
      ISDA_1997_GOVERNMENT_BOND,
      ISDA1998FX,
      ISDA_1999_CREDIT,
      ISDA2000,
      ISDA_2002_EQUITY,
      ISDA_2003_CREDIT,
      ISDA_2004_NOVATION,
      ISDA_2005_COMMODITY,
      ISDA2006,
      ISDA_2006_INFLATION,
      ISDA_2008_INFLATION,
      ISDA_2011_EQUITY,
      ISDA_2014_CREDIT,
   }

   class BermudaExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BermudaExercise";
      public string id { get; set; }
      public AdjustableOrRelativeDates relevantUnderlyingDate { get; set; }
      public BusinessCenterTime earliestExerciseTime { get; set; }
      public BusinessCenterTime expirationTime { get; set; }
      public AdjustableOrRelativeDates bermudaExerciseDates { get; set; }
      public BusinessCenterTime latestExerciseTime { get; set; }
      public MultipleExercise multipleExercise { get; set; }
      public ExerciseFeeSchedule exerciseFeeSchedule { get; set; }
   }
   class BermudaExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BermudaExerciseBuilder";
      public string id { get; set; }
   }
   class ContractualMatrix : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualMatrix";
      public MatrixTypeEnum matrixType { get; set; }
      public DateTime publicationDate { get; set; }
      public MatrixTermEnum matrixTerm { get; set; }
      public string matrixTermScheme { get; set; }
      public string matrixTypeScheme { get; set; }
   }
   class ContractualMatrixBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualMatrixBuilder";
      public MatrixTypeEnum matrixType { get; set; }
      public DateTime publicationDate { get; set; }
      public MatrixTermEnum matrixTerm { get; set; }
      public string matrixTermScheme { get; set; }
      public string matrixTypeScheme { get; set; }
   }
   class PhysicalExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalExercise";
      public Cashflow cashflow { get; set; }
      public Commodity commodity { get; set; }
      public ListedProduct listedProduct { get; set; }
      public Quantity quantity { get; set; }
      public ContractReference[] contractReference { get; set; }
      public Contract[] contract { get; set; }
   }
   class PhysicalExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalExerciseBuilder";
   }
   class InterestRateCurveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRateCurveBuilder";
      public string floatingRateIndexScheme { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
   }
   class InterestRateCurve : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRateCurve";
      public string floatingRateIndexScheme { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period tenor { get; set; }
   }
   class RelativeDateOffset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelativeDateOffset";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class RelativeDateOffsetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelativeDateOffsetBuilder";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class PayoutLineage : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PayoutLineage";
      public string cashflow { get; set; }
      public string optionPayout { get; set; }
      public string creditDefaultPayout { get; set; }
      public string payoutReference { get; set; }
      public string interestRatePayout { get; set; }
   }
   class PayoutLineageBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PayoutLineageBuilder";
      public string cashflow { get; set; }
      public string optionPayout { get; set; }
      public string creditDefaultPayout { get; set; }
      public string payoutReference { get; set; }
      public string interestRatePayout { get; set; }
   }
   class ManualExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ManualExercise";
      public ExerciseNotice exerciseNotice { get; set; }
      public bool fallbackExercise { get; set; }
   }
   class ManualExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ManualExerciseBuilder";
      public bool fallbackExercise { get; set; }
   }
   class GeneralTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GeneralTerms";
      public string additionalTermScheme { get; set; }
      public BuyerSeller buyerSeller { get; set; }
      public ReferenceInformation referenceInformation { get; set; }
      public IndexReferenceInformation indexReferenceInformation { get; set; }
      public bool substitution { get; set; }
      public bool modifiedEquityDelivery { get; set; }
      public BasketReferenceInformation basketReferenceInformation { get; set; }
      public string[] additionalTerm { get; set; }
      public BusinessDayAdjustments dateAdjustments { get; set; }
   }
   class GeneralTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GeneralTermsBuilder";
      public string additionalTermScheme { get; set; }
      public bool substitution { get; set; }
      public bool modifiedEquityDelivery { get; set; }
      public string[] additionalTerm { get; set; }
   }
   class ListedProduct : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ListedProduct";
      public Bond bond { get; set; }
      public ConvertibleBond convertibleBond { get; set; }
      public string rosettaKey { get; set; }
   }
   class ListedProductBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ListedProductBuilder";
   }
   enum RoundingDirectionEnum {
      UP,
      DOWN,
      NEAREST,
   }

   class NewTradePrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NewTradePrimitiveBuilder";
   }
   class NewTradePrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NewTradePrimitive";
      public ContractIdentifier contractReference { get; set; }
      public Contract contract { get; set; }
   }
   class IndexReferenceInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IndexReferenceInformationBuilder";
      public string id { get; set; }
      public int indexAnnexVersion { get; set; }
      public string indexAnnexSourceScheme { get; set; }
      public string indexIdScheme { get; set; }
      public string indexNameScheme { get; set; }
      public int indexSeries { get; set; }
      public string indexName { get; set; }
      public string[] indexId { get; set; }
      public DateTime indexAnnexDate { get; set; }
      public IndexAnnexSourceEnum indexAnnexSource { get; set; }
   }
   class IndexReferenceInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IndexReferenceInformation";
      public string id { get; set; }
      public int indexAnnexVersion { get; set; }
      public string indexAnnexSourceScheme { get; set; }
      public string indexIdScheme { get; set; }
      public string indexNameScheme { get; set; }
      public Tranche tranche { get; set; }
      public int indexSeries { get; set; }
      public string indexName { get; set; }
      public string[] indexId { get; set; }
      public DateTime indexAnnexDate { get; set; }
      public IndexAnnexSourceEnum indexAnnexSource { get; set; }
      public LegalEntity[] excludedReferenceEntity { get; set; }
      public SettledEntityMatrix settledEntityMatrix { get; set; }
   }
   class ContractOrContractReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractOrContractReference";
      public ContractReference[] contractReference { get; set; }
      public Contract[] contract { get; set; }
   }
   class ContractOrContractReferenceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractOrContractReferenceBuilder";
   }
   enum StepRelativeToEnum {
      INITIAL,
      PREVIOUS,
   }

   class TransactedPriceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TransactedPriceBuilder";
      public float initialPoints { get; set; }
      public QuotationStyleEnum quotationStyle { get; set; }
      public float marketFixedRate { get; set; }
      public float marketPrice { get; set; }
   }
   class TransactedPrice : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TransactedPrice";
      public float initialPoints { get; set; }
      public QuotationStyleEnum quotationStyle { get; set; }
      public float marketFixedRate { get; set; }
      public float marketPrice { get; set; }
   }
   class Step : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Step";
      public string id { get; set; }
      public DateTime stepDate { get; set; }
      public float stepValue { get; set; }
   }
   class StepBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StepBuilder";
      public string id { get; set; }
      public DateTime stepDate { get; set; }
      public float stepValue { get; set; }
   }
   class FxLinkedNotionalAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxLinkedNotionalAmount";
      public float notionalAmount { get; set; }
      public DateTime resetDate { get; set; }
      public DateTime adjustedFxSpotFixingDate { get; set; }
      public float observedFxSpotRate { get; set; }
   }
   class FxLinkedNotionalAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxLinkedNotionalAmountBuilder";
      public float notionalAmount { get; set; }
      public DateTime resetDate { get; set; }
      public DateTime adjustedFxSpotFixingDate { get; set; }
      public float observedFxSpotRate { get; set; }
   }
   class EarlyTerminationEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EarlyTerminationEvent";
      public string id { get; set; }
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedExerciseFeePaymentDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class EarlyTerminationEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EarlyTerminationEventBuilder";
      public string id { get; set; }
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedExerciseFeePaymentDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class ObservationPrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ObservationPrimitive";
      public QuotationSideEnum side { get; set; }
      public ObservationSource source { get; set; }
      public float observation { get; set; }
      public DateTime date { get; set; }
      public TimeZone time { get; set; }
   }
   class ObservationPrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ObservationPrimitiveBuilder";
      public QuotationSideEnum side { get; set; }
      public float observation { get; set; }
      public DateTime date { get; set; }
   }
   class ValuationDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ValuationDate";
      public SingleValuationDate singleValuationDate { get; set; }
      public MultipleValuationDates multipleValuationDates { get; set; }
   }
   class ValuationDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ValuationDateBuilder";
   }
   class PartyRole : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyRole";
      public PartyRoleEnum role { get; set; }
      public string partyReference { get; set; }
   }
   class PartyRoleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyRoleBuilder";
      public PartyRoleEnum role { get; set; }
      public string partyReference { get; set; }
   }
   enum TimeUnitEnum {
      SECOND,
      MINUTE,
      HOUR,
      DAY,
      WEEK,
      MONTH,
      YEAR,
   }

   class TimeZone : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TimeZone";
      public string location { get; set; }
      public string locationScheme { get; set; }
      public DateTime time { get; set; }
   }
   class TimeZoneBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TimeZoneBuilder";
      public string location { get; set; }
      public string locationScheme { get; set; }
      public DateTime time { get; set; }
   }
   class Tranche : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Tranche";
      public float attachmentPoint { get; set; }
      public float exhaustionPoint { get; set; }
      public bool incurredRecoveryApplicable { get; set; }
   }
   class TrancheBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TrancheBuilder";
      public float attachmentPoint { get; set; }
      public float exhaustionPoint { get; set; }
      public bool incurredRecoveryApplicable { get; set; }
   }
   class StrategyFeature : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrategyFeature";
      public StrikeSpread strikeSpread { get; set; }
      public CalendarSpread calendarSpread { get; set; }
   }
   class StrategyFeatureBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrategyFeatureBuilder";
   }
   class FloatingAmountEvents : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingAmountEvents";
      public bool failureToPayPrincipal { get; set; }
      public bool writedown { get; set; }
      public bool impliedWritedown { get; set; }
      public AdditionalFixedPayments additionalFixedPayments { get; set; }
      public InterestShortFall interestShortfall { get; set; }
      public FloatingAmountProvisions floatingAmountProvisions { get; set; }
   }
   class FloatingAmountEventsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingAmountEventsBuilder";
      public bool failureToPayPrincipal { get; set; }
      public bool writedown { get; set; }
      public bool impliedWritedown { get; set; }
   }
   class Collateral : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Collateral";
      public IndependentAmount independentAmount { get; set; }
   }
   class CollateralBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CollateralBuilder";
   }
   class CurveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CurveBuilder";
      public string commodityCurveScheme { get; set; }
      public CommodityReferencePriceEnum commodityCurve { get; set; }
   }
   class Curve : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Curve";
      public string commodityCurveScheme { get; set; }
      public InterestRateCurve interestRateCurve { get; set; }
      public CommodityReferencePriceEnum commodityCurve { get; set; }
   }
   class PassThrough : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PassThrough";
      public PassThroughItem[] passThroughItem { get; set; }
   }
   class PassThroughBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PassThroughBuilder";
   }
   enum QuotationStyleEnum {
      POINTS_UP_FRONT,
      TRADED_SPREAD,
      PRICE,
   }

   class ReferencePoolItemBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePoolItemBuilder";
      public string protectionTermsReference { get; set; }
      public string settlementTermsReference { get; set; }
   }
   class ReferencePoolItem : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePoolItem";
      public ReferencePair referencePair { get; set; }
      public string protectionTermsReference { get; set; }
      public string settlementTermsReference { get; set; }
      public ConstituentWeight constituentWeight { get; set; }
   }
   class StubPeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubPeriod";
      public string calculationPeriodDatesReference { get; set; }
      public StubValue initialStub { get; set; }
      public StubValue finalStub { get; set; }
   }
   class StubPeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubPeriodBuilder";
      public string calculationPeriodDatesReference { get; set; }
   }
   class Event : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Event";
      public DateTime effectiveDate { get; set; }
      public PrimitiveEvent primitive { get; set; }
      public Lineage lineage { get; set; }
      public MessageInformation messageInformation { get; set; }
      public Identifier eventIdentifier { get; set; }
      public string eventQualifier { get; set; }
      public DateTime eventDate { get; set; }
      public ActionEnum action { get; set; }
      public IntentEnum intent { get; set; }
      public string functionCall { get; set; }
      public EventEffect eventEffect { get; set; }
      public Party[] party { get; set; }
      public string rosettaKey { get; set; }
      public EventTimestamp timestamp { get; set; }
   }
   class EventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventBuilder";
      public DateTime effectiveDate { get; set; }
      public string eventQualifier { get; set; }
      public DateTime eventDate { get; set; }
      public ActionEnum action { get; set; }
      public IntentEnum intent { get; set; }
      public string functionCall { get; set; }
   }
   class Transfer : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Transfer";
      public GrossCashflow[] grossCashflow { get; set; }
      public string settlementReference { get; set; }
      public string rosettaKey { get; set; }
      public AdjustableOrAdjustedOrRelativeDate transferDate { get; set; }
      public string transferCalculation { get; set; }
      public TransferTypeEnum transferType { get; set; }
      public TransferStatusEnum transferStatus { get; set; }
      public PayerReceiver payerReceiver { get; set; }
      public Asset asset { get; set; }
      public TransferorTransferee transferorTransferee { get; set; }
      public Quantity quantity { get; set; }
      public Money amount { get; set; }
   }
   class TransferBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TransferBuilder";
      public string settlementReference { get; set; }
      public string transferCalculation { get; set; }
      public TransferTypeEnum transferType { get; set; }
      public TransferStatusEnum transferStatus { get; set; }
   }
   enum SpreadScheduleTypeEnum {
      LONG,
      SHORT,
   }

   class AdditionalFixedPayments : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdditionalFixedPayments";
      public bool interestShortfallReimbursement { get; set; }
      public bool principalShortfallReimbursement { get; set; }
      public bool writedownReimbursement { get; set; }
   }
   class AdditionalFixedPaymentsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdditionalFixedPaymentsBuilder";
      public bool interestShortfallReimbursement { get; set; }
      public bool principalShortfallReimbursement { get; set; }
      public bool writedownReimbursement { get; set; }
   }
   class EuropeanExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EuropeanExerciseBuilder";
      public string id { get; set; }
   }
   class EuropeanExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EuropeanExercise";
      public string id { get; set; }
      public AdjustableOrRelativeDate expirationDate { get; set; }
      public AdjustableOrRelativeDates relevantUnderlyingDate { get; set; }
      public BusinessCenterTime earliestExerciseTime { get; set; }
      public BusinessCenterTime expirationTime { get; set; }
      public PartialExercise partialExercise { get; set; }
      public ExerciseFee exerciseFee { get; set; }
   }
   enum CreditSeniorityTradingEnum {
      SENIOR,
      SUBORDINATE,
   }

   class Barrier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Barrier";
      public TriggerEvent barrierCap { get; set; }
      public TriggerEvent barrierFloor { get; set; }
   }
   class BarrierBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BarrierBuilder";
   }
   enum QuoteBasisEnum {
      CURRENCY_1_PER_CURRENCY_2,
      CURRENCY_2_PER_CURRENCY_1,
   }

   class BusinessDayAdjustments : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessDayAdjustments";
      public string id { get; set; }
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
   }
   class BusinessDayAdjustmentsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessDayAdjustmentsBuilder";
      public string id { get; set; }
      public BusinessDayConventionEnum businessDayConvention { get; set; }
   }
   enum PeriodExtendedEnum {
      T,
      D,
      W,
      M,
      Y,
   }

   class FloatingRateDefinition : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRateDefinition";
      public float floatingRateMultiplier { get; set; }
      public float spread { get; set; }
      public float calculatedRate { get; set; }
      public RateObservation[] rateObservation { get; set; }
      public Strike[] capRate { get; set; }
      public Strike[] floorRate { get; set; }
   }
   class FloatingRateDefinitionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRateDefinitionBuilder";
      public float floatingRateMultiplier { get; set; }
      public float spread { get; set; }
      public float calculatedRate { get; set; }
   }
   class AllocationPrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AllocationPrimitiveBuilder";
   }
   class AllocationPrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AllocationPrimitive";
      public Execution before { get; set; }
      public AllocationOutcome after { get; set; }
   }
   class FxRateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxRateBuilder";
      public float rate { get; set; }
   }
   class FxRate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxRate";
      public QuotedCurrencyPair quotedCurrencyPair { get; set; }
      public float rate { get; set; }
   }
   class ExtendibleProvisionAdjustedDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtendibleProvisionAdjustedDatesBuilder";
   }
   class ExtendibleProvisionAdjustedDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtendibleProvisionAdjustedDates";
      public ExtensionEvent[] extensionEvent { get; set; }
   }
   class RelativeDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelativeDatesBuilder";
      public int periodSkip { get; set; }
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class RelativeDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelativeDates";
      public int periodSkip { get; set; }
      public DateRange scheduleBounds { get; set; }
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   enum ActionEnum {
      NEW,
      CORRECT,
      CANCEL,
   }

   class OptionStrike : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionStrike";
      public string currency { get; set; }
      public float spread { get; set; }
      public ReferenceSwapCurve referenceSwapCurve { get; set; }
      public float price { get; set; }
      public float percentage { get; set; }
      public string strikeReference { get; set; }
      public string currencyScheme { get; set; }
   }
   class OptionStrikeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionStrikeBuilder";
      public string currency { get; set; }
      public float spread { get; set; }
      public float price { get; set; }
      public float percentage { get; set; }
      public string strikeReference { get; set; }
      public string currencyScheme { get; set; }
   }
   class ResetPrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetPrimitive";
      public Cashflow cashflow { get; set; }
      public float resetValue { get; set; }
      public string rosettaKey { get; set; }
      public DateTime date { get; set; }
   }
   class ResetPrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetPrimitiveBuilder";
      public float resetValue { get; set; }
      public DateTime date { get; set; }
   }
   class AveragingPeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingPeriodBuilder";
      public string marketDisruptionScheme { get; set; }
      public MarketDisruptionEnum marketDisruption { get; set; }
   }
   class AveragingPeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingPeriod";
      public string marketDisruptionScheme { get; set; }
      public DateTimeList averagingDateTimes { get; set; }
      public AveragingObservationList averagingObservations { get; set; }
      public MarketDisruptionEnum marketDisruption { get; set; }
      public AveragingSchedule[] schedule { get; set; }
   }
   class PercentageRuleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PercentageRuleBuilder";
      public float paymentPercent { get; set; }
      public string notionalAmountReference { get; set; }
   }
   class PercentageRule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PercentageRule";
      public float paymentPercent { get; set; }
      public string notionalAmountReference { get; set; }
   }
   class CalculationAgent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAgent";
      public string calculationAgentBusinessCenterScheme { get; set; }
      public BusinessCenterEnum calculationAgentBusinessCenter { get; set; }
      public string[] calculationAgentPartyReference { get; set; }
      public CalculationAgentPartyEnum calculationAgentParty { get; set; }
   }
   class CalculationAgentBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAgentBuilder";
      public string calculationAgentBusinessCenterScheme { get; set; }
      public BusinessCenterEnum calculationAgentBusinessCenter { get; set; }
      public string[] calculationAgentPartyReference { get; set; }
      public CalculationAgentPartyEnum calculationAgentParty { get; set; }
   }
   class NaturalPerson : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NaturalPerson";
      public string id { get; set; }
      public string honorific { get; set; }
      public string firstName { get; set; }
      public string[] middleName { get; set; }
      public string[] initial { get; set; }
      public string surname { get; set; }
      public string suffix { get; set; }
      public DateTime dateOfBirth { get; set; }
   }
   class NaturalPersonBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NaturalPersonBuilder";
      public string id { get; set; }
      public string honorific { get; set; }
      public string firstName { get; set; }
      public string[] middleName { get; set; }
      public string[] initial { get; set; }
      public string surname { get; set; }
      public string suffix { get; set; }
      public DateTime dateOfBirth { get; set; }
   }
   class BusinessDateRangeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessDateRangeBuilder";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public DateTime unadjustedFirstDate { get; set; }
      public DateTime unadjustedLastDate { get; set; }
   }
   class BusinessDateRange : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessDateRange";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
      public DateTime unadjustedFirstDate { get; set; }
      public DateTime unadjustedLastDate { get; set; }
   }
   class CancelableProvision : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancelableProvision";
      public bool followUpConfirmation { get; set; }
      public AmericanExercise americanExercise { get; set; }
      public BermudaExercise bermudaExercise { get; set; }
      public EuropeanExercise europeanExercise { get; set; }
      public ExerciseNotice exerciseNotice { get; set; }
      public SimplePayment initialFee { get; set; }
      public CancelableProvisionAdjustedDates cancelableProvisionAdjustedDates { get; set; }
      public FinalCalculationPeriodDateAdjustment[] finalCalculationPeriodDateAdjustment { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   class CancelableProvisionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancelableProvisionBuilder";
      public bool followUpConfirmation { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   enum BrokerConfirmationTypeEnum {
      ABX,
      CD_SON_MBS,
   }

   enum QuotationRateTypeEnum {
      BID,
      ASK,
      MID,
      EXERCISING_PARTY_PAYS,
   }

   class PriceSourceDisruptionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PriceSourceDisruptionBuilder";
   }
   class PriceSourceDisruption : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PriceSourceDisruption";
      public FallbackReferencePrice fallbackReferencePrice { get; set; }
   }
   class CreditDefaultPayout : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditDefaultPayout";
      public string id { get; set; }
      public PhysicalSettlementTerms physicalSettlementTerms { get; set; }
      public string rosettaKeyValue { get; set; }
      public ProtectionTerms protectionTerms { get; set; }
      public GeneralTerms generalTerms { get; set; }
      public CashSettlementTerms cashSettlementTerms { get; set; }
      public TransactedPrice transactedPrice { get; set; }
   }
   class CreditDefaultPayoutBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditDefaultPayoutBuilder";
      public string id { get; set; }
   }
   class CashPriceMethodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashPriceMethodBuilder";
      public string cashSettlementCurrencyScheme { get; set; }
      public string cashSettlementCurrency { get; set; }
      public QuotationRateTypeEnum quotationRateType { get; set; }
   }
   class CashPriceMethod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashPriceMethod";
      public string cashSettlementCurrencyScheme { get; set; }
      public CashSettlementReferenceBanks cashSettlementReferenceBanks { get; set; }
      public string cashSettlementCurrency { get; set; }
      public QuotationRateTypeEnum quotationRateType { get; set; }
   }
   enum TimeTypeEnum {
      CLOSE,
      OPEN,
      OSP,
      SPECIFIC_TIME,
      XETRA,
      DERIVATIVES_CLOSE,
      AS_SPECIFIED_IN_MASTER_CONFIRMATION,
   }

   enum InformationProviderEnum {
      BANK_OF_JAPAN,
      BLOOMBERG,
      ISDA,
      REUTERS,
      TELERATE,
      OTHER,
   }

   enum RollConventionEnum {
      EOM,
      FRN,
      IMM,
      IMMCAD,
      IMMAUD,
      IMMNZD,
      SFE,
      NONE,
      TBILL,
      _1,
      _2,
      _3,
      _4,
      _5,
      _6,
      _7,
      _8,
      _9,
      _10,
      _11,
      _12,
      _13,
      _14,
      _15,
      _16,
      _17,
      _18,
      _19,
      _20,
      _21,
      _22,
      _23,
      _24,
      _25,
      _26,
      _27,
      _28,
      _29,
      _30,
      MON,
      TUE,
      WED,
      THU,
      FRI,
      SAT,
      SUN,
   }

   class Mortgage : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Mortgage";
      public Period paymentFrequency { get; set; }
      public string dayCountFractionScheme { get; set; }
      public string sectorScheme { get; set; }
      public string tranche { get; set; }
      public Party insurer { get; set; }
      public string insurerReference { get; set; }
      public float originalPrincipalAmount { get; set; }
      public MortgageSectorEnum sector { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public AssetPool pool { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class MortgageBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MortgageBuilder";
      public string dayCountFractionScheme { get; set; }
      public string sectorScheme { get; set; }
      public string tranche { get; set; }
      public string insurerReference { get; set; }
      public float originalPrincipalAmount { get; set; }
      public MortgageSectorEnum sector { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   enum AssetClassEnum {
      COMMODITY,
      CREDIT,
      EQUITY,
      FOREIGN_EXCHANGE,
      INTEREST_RATE,
   }

   enum GoverningLawEnum {
      AS_SPECIFIED_IN_MASTER_AGREEMENT,
   }

   enum CategoryEnum {
      TBD,
   }

   class PaymentDiscounting : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDiscounting";
      public float discountFactor { get; set; }
      public Money presentValueAmount { get; set; }
   }
   class PaymentDiscountingBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDiscountingBuilder";
      public float discountFactor { get; set; }
   }
   class ReferenceSwapCurve : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceSwapCurve";
      public SwapCurveValuation swapUnwindValue { get; set; }
      public MakeWholeAmount makeWholeAmount { get; set; }
   }
   class ReferenceSwapCurveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceSwapCurveBuilder";
   }
   class InterestRate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRate";
      public FloatingRateCalculation floatingRate { get; set; }
      public InflationRateCalculation inflationRate { get; set; }
      public Schedule fixedRate { get; set; }
   }
   class InterestRateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRateBuilder";
   }
   class PartyContractIdentifierBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyContractIdentifierBuilder";
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class PartyContractIdentifier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyContractIdentifier";
      public LinkId[] linkId { get; set; }
      public ContractIdentifier[] allocationTradeId { get; set; }
      public ContractIdentifierExtended[] resultingTradeId { get; set; }
      public ContractIdentifier blockTradeId { get; set; }
      public ContractIdentifier[] originatingTradeId { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public IdentifierValue identifierValue { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   enum OptionTypeEnum {
      PUT,
      CALL,
      PAYER,
      RECEIVER,
      STRADDLE,
   }

   class ConvertibleBondBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ConvertibleBondBuilder";
      public DateTime redemptionDate { get; set; }
      public string dayCountFractionScheme { get; set; }
      public float parValue { get; set; }
      public float issuanceFaceAmount { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class ConvertibleBond : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ConvertibleBond";
      public EquityAsset underlyingEquity { get; set; }
      public DateTime redemptionDate { get; set; }
      public Period paymentFrequency { get; set; }
      public string dayCountFractionScheme { get; set; }
      public float parValue { get; set; }
      public float issuanceFaceAmount { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class Offset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Offset";
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class OffsetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OffsetBuilder";
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   enum StandardSettlementStyleEnum {
      STANDARD,
      NET,
      STANDARD_AND_NET,
   }

   class PaymentDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDates";
      public string id { get; set; }
      public Frequency paymentFrequency { get; set; }
      public Offset paymentDaysOffset { get; set; }
      public DateTime lastRegularPaymentDate { get; set; }
      public string resetDatesReference { get; set; }
      public string valuationDatesReference { get; set; }
      public bool paymentDelay { get; set; }
      public PayRelativeToEnum payRelativeTo { get; set; }
      public DateTime firstPaymentDate { get; set; }
      public string calculationPeriodDatesReference { get; set; }
      public BusinessDayAdjustments paymentDatesAdjustments { get; set; }
   }
   class PaymentDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentDatesBuilder";
      public string id { get; set; }
      public DateTime lastRegularPaymentDate { get; set; }
      public string resetDatesReference { get; set; }
      public string valuationDatesReference { get; set; }
      public bool paymentDelay { get; set; }
      public PayRelativeToEnum payRelativeTo { get; set; }
      public DateTime firstPaymentDate { get; set; }
      public string calculationPeriodDatesReference { get; set; }
   }
   class QuotedCurrencyPair : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuotedCurrencyPair";
      public string currency1 { get; set; }
      public string currency2 { get; set; }
      public QuoteBasisEnum quoteBasis { get; set; }
      public string currency1Scheme { get; set; }
      public string currency2Scheme { get; set; }
   }
   class QuotedCurrencyPairBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuotedCurrencyPairBuilder";
      public string currency1 { get; set; }
      public string currency2 { get; set; }
      public QuoteBasisEnum quoteBasis { get; set; }
      public string currency1Scheme { get; set; }
      public string currency2Scheme { get; set; }
   }
   class ObservationSource : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ObservationSource";
      public Curve curve { get; set; }
      public InformationSource informationSource { get; set; }
   }
   class ObservationSourceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ObservationSourceBuilder";
   }
   class ContractIdentifierExtended : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractIdentifierExtended";
      public string associatedParty { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public IdentifierValue identifierValue { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class ContractIdentifierExtendedBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractIdentifierExtendedBuilder";
      public string associatedParty { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class StrikeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrikeBuilder";
      public string id { get; set; }
      public PayerReceiverEnum buyer { get; set; }
      public PayerReceiverEnum seller { get; set; }
      public float strikeRate { get; set; }
   }
   class Strike : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Strike";
      public string id { get; set; }
      public PayerReceiverEnum buyer { get; set; }
      public PayerReceiverEnum seller { get; set; }
      public float strikeRate { get; set; }
   }
   enum PaymentTypeEnum {
      NET_CASHFLOW,
      BROKERAGE_COMMISSION,
      FEE,
      INTEREST,
      NET_INTEREST,
      NOVATION_FEE,
      PREMIUM,
      TERMINATION_FEE,
   }

   class StrikeSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrikeSchedule";
      public PayerReceiverEnum buyer { get; set; }
      public PayerReceiverEnum seller { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
      public Step[] step { get; set; }
   }
   class StrikeScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrikeScheduleBuilder";
      public PayerReceiverEnum buyer { get; set; }
      public PayerReceiverEnum seller { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   enum AveragingMethodEnum {
      UNWEIGHTED,
      WEIGHTED,
   }

   enum IntentEnum {
      ALLOCATION,
      COMPRESSION,
      CORRECTION,
      EARLY_TERMINATION,
      EXERCISE,
      INCREASE,
      NEW_TRADE,
      NOVATION,
      PARTIAL_NOVATION,
      PARTIAL_TERMINATION,
      PORTFOLIO_COMPRESSION,
      RENEGOTIATION,
      TERMINATION,
   }

   class ExercisePrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExercisePrimitive";
      public ContractOrContractReference before { get; set; }
      public DateTime exerciseDate { get; set; }
      public DateTime exerciseTime { get; set; }
      public bool fullExercise { get; set; }
      public ExerciseOutcome after { get; set; }
   }
   class ExercisePrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExercisePrimitiveBuilder";
      public DateTime exerciseDate { get; set; }
      public DateTime exerciseTime { get; set; }
      public bool fullExercise { get; set; }
   }
   enum DayOfWeekEnum {
      MON,
      TUE,
      WED,
      THU,
      FRI,
      SAT,
      SUN,
   }

   enum AccountTypeEnum {
      AGGREGATE_CLIENT,
      CLIENT,
      HOUSE,
   }

   class AdjustedRelativeDateOffset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustedRelativeDateOffset";
      public BusinessDayAdjustments relativeDateAdjustments { get; set; }
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class AdjustedRelativeDateOffsetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustedRelativeDateOffsetBuilder";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string businessCentersReference { get; set; }
      public string dateRelativeTo { get; set; }
      public DateTime adjustedDate { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class CreditSupportAgreementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditSupportAgreementBuilder";
      public CreditSupportAgreementTypeEnum type { get; set; }
      public string identifierValue { get; set; }
      public DateTime date { get; set; }
      public string typeScheme { get; set; }
   }
   class CreditSupportAgreement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditSupportAgreement";
      public CreditSupportAgreementTypeEnum type { get; set; }
      public string identifierValue { get; set; }
      public DateTime date { get; set; }
      public string typeScheme { get; set; }
   }
   enum PaymentStatusEnum {
      DISPUTED,
      INSTRUCTED,
      PENDING,
      SETTLED,
   }

   class LinkId : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LinkId";
      public string id { get; set; }
      public string linkId { get; set; }
      public string linkIdScheme { get; set; }
   }
   class LinkIdBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LinkIdBuilder";
      public string id { get; set; }
      public string linkId { get; set; }
      public string linkIdScheme { get; set; }
   }
   enum MasterConfirmationTypeEnum {
      CREDIT_INDEX_2003,
      DJ_CDX_NA,
      DJ_I_TRAXX_EUROPE,
      ISDA_1999_CREDIT,
      ISDA_2003_CREDIT_JAPAN,
      ISDA_2003_CREDIT_NORTH_AMERICAN,
   }

   enum MatrixTypeEnum {
      CREDIT_DERIVATIVES_PHYSICAL_SETTLEMENT_MATRIX,
      EQUITY_DERIVATIVES_MATRIX,
      SETTLEMENT_MATRIX,
   }

   class ExtendibleProvisionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtendibleProvisionBuilder";
      public bool followUpConfirmation { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   class ExtendibleProvision : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtendibleProvision";
      public bool followUpConfirmation { get; set; }
      public AmericanExercise americanExercise { get; set; }
      public BermudaExercise bermudaExercise { get; set; }
      public EuropeanExercise europeanExercise { get; set; }
      public ExerciseNotice exerciseNotice { get; set; }
      public ExtendibleProvisionAdjustedDates extendibleProvisionAdjustedDates { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   enum InterestShortfallCapEnum {
      FIXED,
      VARIABLE,
   }

   class ExtensionEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtensionEvent";
      public string id { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
      public DateTime adjustedExtendedTerminationDate { get; set; }
   }
   class ExtensionEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExtensionEventBuilder";
      public string id { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
      public DateTime adjustedExtendedTerminationDate { get; set; }
   }
   enum CreditSeniorityEnum {
      OTHER,
      SENIOR_SEC,
      SENIOR_UN_SEC,
      SUB_LOWER_TIER_2,
      SUB_TIER_1,
      SUB_TIER_3,
      SUB_UPPER_TIER_2,
   }

   enum InterpolationMethodEnum {
      LINEAR_ZERO_YIELD,
      NONE,
   }

   class AdjustableOrAdjustedDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrAdjustedDate";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public DateTime adjustedDate { get; set; }
      public BusinessDayAdjustments dateAdjustments { get; set; }
   }
   class AdjustableOrAdjustedDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrAdjustedDateBuilder";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public DateTime adjustedDate { get; set; }
   }
   class BuyerSeller : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BuyerSeller";
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   class BuyerSellerBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BuyerSellerBuilder";
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   class PaymentBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentBuilder";
      public PaymentTypeEnum paymentType { get; set; }
      public PaymentStatusEnum paymentStatus { get; set; }
      public string settlementReference { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
   }
   class Payment : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Payment";
      public PaymentTypeEnum paymentType { get; set; }
      public AdjustableOrAdjustedOrRelativeDate paymentDate { get; set; }
      public GrossCashflow[] grossCashflow { get; set; }
      public PaymentStatusEnum paymentStatus { get; set; }
      public string settlementReference { get; set; }
      public string rosettaKey { get; set; }
      public Money paymentAmount { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
      public Money presentValueAmount { get; set; }
      public PremiumExpression premiumExpression { get; set; }
      public PaymentDiscounting paymentDiscounting { get; set; }
      public PayerReceiver payerReceiver { get; set; }
   }
   enum LengthUnitEnum {
      PAGES,
      TIME_UNIT,
   }

   class SingleValuationDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SingleValuationDateBuilder";
      public int businessDays { get; set; }
   }
   class SingleValuationDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SingleValuationDate";
      public int businessDays { get; set; }
   }
   enum PayerReceiverEnum {
      PAYER,
      RECEIVER,
   }

   class FloatingRateCalculation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRateCalculation";
      public float initialRate { get; set; }
      public Rounding finalRateRounding { get; set; }
      public AveragingMethodEnum averagingMethod { get; set; }
      public NegativeInterestRateTreatmentEnum negativeInterestRateTreatment { get; set; }
      public string id { get; set; }
      public SpreadSchedule[] spreadSchedule { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public Schedule floatingRateMultiplierSchedule { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
      public StrikeSchedule[] capRateSchedule { get; set; }
      public StrikeSchedule[] floorRateSchedule { get; set; }
   }
   class FloatingRateCalculationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRateCalculationBuilder";
      public float initialRate { get; set; }
      public AveragingMethodEnum averagingMethod { get; set; }
      public NegativeInterestRateTreatmentEnum negativeInterestRateTreatment { get; set; }
      public string id { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
   }
   class EventTestBundleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventTestBundleBuilder";
   }
   class EventTestBundle : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventTestBundle";
      public Event[] event { get; set; }
      public ComputedAmount[] computedAmount { get; set; }
   }
   class NonDeliverableSettlementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonDeliverableSettlementBuilder";
      public string referenceCurrency { get; set; }
      public SettlementRateOptionEnum settlementRateOption { get; set; }
      public string referenceCurrencyScheme { get; set; }
      public string settlementRateOptionScheme { get; set; }
   }
   class NonDeliverableSettlement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonDeliverableSettlement";
      public string referenceCurrency { get; set; }
      public FxFixingDate fxFixingDate { get; set; }
      public AdjustableDates fxFixingSchedule { get; set; }
      public SettlementRateOptionEnum settlementRateOption { get; set; }
      public PriceSourceDisruption priceSourceDisruption { get; set; }
      public string referenceCurrencyScheme { get; set; }
      public string settlementRateOptionScheme { get; set; }
   }
   class AutomaticExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AutomaticExercise";
      public float thresholdRate { get; set; }
   }
   class AutomaticExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AutomaticExerciseBuilder";
      public float thresholdRate { get; set; }
   }
   enum MasterConfirmationAnnexTypeEnum {
      ISDA_2004_INDEX_VARIANCE_SWAP_AMERICAS_INTERDEALER,
   }

   class CalculationPeriodFrequency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriodFrequency";
      public RollConventionEnum rollConvention { get; set; }
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class CalculationPeriodFrequencyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriodFrequencyBuilder";
      public RollConventionEnum rollConvention { get; set; }
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class CashflowRepresentationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashflowRepresentationBuilder";
      public bool cashflowsMatchParameters { get; set; }
   }
   class CashflowRepresentation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashflowRepresentation";
      public bool cashflowsMatchParameters { get; set; }
      public PrincipalExchange[] principalExchange { get; set; }
      public PaymentCalculationPeriod[] paymentCalculationPeriod { get; set; }
   }
   class DiscountingBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DiscountingBuilder";
      public DayCountFractionEnum discountRateDayCountFraction { get; set; }
      public float discountRate { get; set; }
      public DiscountingTypeEnum discountingType { get; set; }
      public string discountRateDayCountFractionScheme { get; set; }
   }
   class Discounting : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Discounting";
      public DayCountFractionEnum discountRateDayCountFraction { get; set; }
      public float discountRate { get; set; }
      public DiscountingTypeEnum discountingType { get; set; }
      public string discountRateDayCountFractionScheme { get; set; }
   }
   class YieldCurveMethod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.YieldCurveMethod";
      public QuotationRateTypeEnum quotationRateType { get; set; }
      public SettlementRateSource settlementRateSource { get; set; }
   }
   class YieldCurveMethodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.YieldCurveMethodBuilder";
      public QuotationRateTypeEnum quotationRateType { get; set; }
   }
   enum CreditSupportAgreementTypeEnum {
      ISDA_1994_CREDIT_SUPPORT_ANNEX_NEW_YORK_LAW,
      ISDA_1995_CREDIT_SUPPORT_ANNEX_ENGLISH_LAW,
      ISDA_1995_CREDIT_SUPPORT_ANNEX_JAPANESE_LAW,
      ISDA_1995_CREDIT_SUPPORT_DEED_ENGLISH_LAW,
      ISDA_2001_MARGIN_PROVISIONS,
      ISDA_2013_STANDARD_CREDIT_SUPPORT_AGREEMENT,
      ISDA_2014_STANDARD_CREDIT_SUPPORT_AGREEMENT,
   }

   class OptionExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionExercise";
      public OptionStyle optionStyle { get; set; }
      public OptionStrike strike { get; set; }
      public ExerciseProcedure exerciseProcedure { get; set; }
      public OptionSettlement settlement { get; set; }
   }
   class OptionExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionExerciseBuilder";
   }
   class CashSettlementPaymentDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementPaymentDateBuilder";
      public string id { get; set; }
   }
   class CashSettlementPaymentDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementPaymentDate";
      public string id { get; set; }
      public AdjustableDates adjustableDates { get; set; }
      public BusinessDateRange businessDateRange { get; set; }
      public RelativeDateOffset relativeDate { get; set; }
   }
   class DateList : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateList";
      public DateTime[] date { get; set; }
   }
   class DateListBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateListBuilder";
      public DateTime[] date { get; set; }
   }
   class DateRange : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRange";
      public DateTime unadjustedFirstDate { get; set; }
      public DateTime unadjustedLastDate { get; set; }
   }
   class DateRangeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRangeBuilder";
      public DateTime unadjustedFirstDate { get; set; }
      public DateTime unadjustedLastDate { get; set; }
   }
   class PrimitiveEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrimitiveEvent";
      public Payment[] payment { get; set; }
      public ObservationPrimitive[] observation { get; set; }
      public Transfer[] transfer { get; set; }
      public NewTradePrimitive[] newTrade { get; set; }
      public Inception[] inception { get; set; }
      public QuantityChangePrimitive[] quantityChange { get; set; }
      public AllocationPrimitive[] allocation { get; set; }
      public TermsChangePrimitive termsChange { get; set; }
      public ExercisePrimitive exercise { get; set; }
      public ResetPrimitive[] reset { get; set; }
   }
   class PrimitiveEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrimitiveEventBuilder";
   }
   class StubValueBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubValueBuilder";
      public float stubRate { get; set; }
   }
   class StubValue : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubValue";
      public StubFloatingRate[] floatingRate { get; set; }
      public float stubRate { get; set; }
      public Money stubAmount { get; set; }
   }
   enum PartyRoleEnum {
      BARRIER_DETERMINATION_AGENT,
      BENEFICIARY,
      BROKER,
      DETERMINING_PARTY,
      HEDGING_PARTY,
   }

   class GrossCashflowBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GrossCashflowBuilder";
      public string cashflowCalculation { get; set; }
      public CashflowTypeEnum cashflowType { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
   }
   class GrossCashflow : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GrossCashflow";
      public PayoutLineage payoutLineage { get; set; }
      public string cashflowCalculation { get; set; }
      public CashflowTypeEnum cashflowType { get; set; }
      public Money cashflowAmount { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
      public Money presentValueAmount { get; set; }
      public PremiumExpression premiumExpression { get; set; }
      public PaymentDiscounting paymentDiscounting { get; set; }
      public PayerReceiver payerReceiver { get; set; }
   }
   class NaturalPersonRole : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NaturalPersonRole";
      public NaturalPersonRoleEnum role { get; set; }
      public string personReference { get; set; }
      public string roleScheme { get; set; }
   }
   class NaturalPersonRoleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NaturalPersonRoleBuilder";
      public NaturalPersonRoleEnum role { get; set; }
      public string personReference { get; set; }
      public string roleScheme { get; set; }
   }
   enum QuantityTypeEnum {
      UNITS,
      CONTRACTS,
      UNITS_OF_MEASURE_PER_TIME_UNIT,
   }

   enum EntityTypeEnum {
      ASIAN,
      AUSTRALIAN_AND_NEW_ZEALAND,
      EUROPEAN_EMERGING_MARKETS,
      JAPANESE,
      NORTH_AMERICAN_HIGH_YIELD,
      NORTH_AMERICAN_INSURANCE,
      NORTH_AMERICAN_INVESTMENT_GRADE,
      SINGAPOREAN,
      WESTERN_EUROPEAN,
      WESTERN_EUROPEAN_INSURANCE,
   }

   class FxFixingDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxFixingDate";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public BusinessCenters businessCenters { get; set; }
      public string businessCentersReference { get; set; }
      public DateRelativeToPaymentDates dateRelativeToPaymentDates { get; set; }
      public DateRelativeToCalculationPeriodDates dateRelativeToCalculationPeriodDates { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class FxFixingDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxFixingDateBuilder";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string businessCentersReference { get; set; }
      public DayTypeEnum dayType { get; set; }
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class RelatedParty : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelatedParty";
      public PartyRoleEnum role { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
   }
   class RelatedPartyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RelatedPartyBuilder";
      public PartyRoleEnum role { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
   }
   class SimplePayment : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SimplePayment";
      public string id { get; set; }
      public AdjustableOrRelativeDate paymentDate { get; set; }
      public Money paymentAmount { get; set; }
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   class SimplePaymentBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SimplePaymentBuilder";
      public string id { get; set; }
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   enum ResetRelativeToEnum {
      CALCULATION_PERIOD_START_DATE,
      CALCULATION_PERIOD_END_DATE,
   }

   class Product : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Product";
      public ListedProduct listedProduct { get; set; }
      public ContractualProduct contractualProduct { get; set; }
   }
   class ProductBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductBuilder";
   }
   class ResetDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetDates";
      public string id { get; set; }
      public Offset rateCutOffDaysOffset { get; set; }
      public ResetRelativeToEnum resetRelativeTo { get; set; }
      public InitialFixingDate initialFixingDate { get; set; }
      public AdjustableDate finalFixingDate { get; set; }
      public RelativeDateOffset fixingDates { get; set; }
      public string calculationPeriodDatesReference { get; set; }
      public ResetFrequency resetFrequency { get; set; }
      public BusinessDayAdjustments resetDatesAdjustments { get; set; }
   }
   class ResetDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetDatesBuilder";
      public string id { get; set; }
      public ResetRelativeToEnum resetRelativeTo { get; set; }
      public string calculationPeriodDatesReference { get; set; }
   }
   class NotDomesticCurrencyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotDomesticCurrencyBuilder";
      public string currency { get; set; }
      public bool applicable { get; set; }
      public string currencyScheme { get; set; }
   }
   class NotDomesticCurrency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotDomesticCurrency";
      public string currency { get; set; }
      public bool applicable { get; set; }
      public string currencyScheme { get; set; }
   }
   class AdjustableOrRelativeDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrRelativeDate";
      public string id { get; set; }
      public AdjustableDate adjustableDate { get; set; }
      public RelativeDateOffset relativeDate { get; set; }
   }
   class AdjustableOrRelativeDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrRelativeDateBuilder";
      public string id { get; set; }
   }
   enum FraDiscountingEnum {
      ISDA,
      AFMA,
      NONE,
      ISDA_YIELD,
   }

   class FxLinkedNotionalScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxLinkedNotionalScheduleBuilder";
      public string varyingNotionalCurrency { get; set; }
      public string constantNotionalScheduleReference { get; set; }
      public float initialValue { get; set; }
      public string varyingNotionalCurrencyScheme { get; set; }
   }
   class FxLinkedNotionalSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxLinkedNotionalSchedule";
      public string varyingNotionalCurrency { get; set; }
      public FxSpotRateSource fxSpotRateSource { get; set; }
      public string constantNotionalScheduleReference { get; set; }
      public RelativeDateOffset varyingNotionalFixingDates { get; set; }
      public RelativeDateOffset varyingNotionalInterimExchangePaymentDates { get; set; }
      public float initialValue { get; set; }
      public string varyingNotionalCurrencyScheme { get; set; }
   }
   class MultipleExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MultipleExercise";
      public float maximumNumberOfOptions { get; set; }
      public float maximumNotionalAmount { get; set; }
      public int minimumNumberOfOptions { get; set; }
      public string notionaReference { get; set; }
      public float integralMultipleAmount { get; set; }
      public float minimumNotionalAmount { get; set; }
   }
   class MultipleExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MultipleExerciseBuilder";
      public float maximumNumberOfOptions { get; set; }
      public float maximumNotionalAmount { get; set; }
      public int minimumNumberOfOptions { get; set; }
      public string notionaReference { get; set; }
      public float integralMultipleAmount { get; set; }
      public float minimumNotionalAmount { get; set; }
   }
   class PCDeliverableObligationCharacBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PCDeliverableObligationCharacBuilder";
      public bool applicable { get; set; }
      public bool partialCashSettlement { get; set; }
   }
   class PCDeliverableObligationCharac : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PCDeliverableObligationCharac";
      public bool applicable { get; set; }
      public bool partialCashSettlement { get; set; }
   }
   class FloatingAmountProvisions : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingAmountProvisions";
      public bool wacCapInterestProvision { get; set; }
      public bool stepUpProvision { get; set; }
   }
   class FloatingAmountProvisionsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingAmountProvisionsBuilder";
      public bool wacCapInterestProvision { get; set; }
      public bool stepUpProvision { get; set; }
   }
   enum DayTypeEnum {
      BUSINESS,
      CALENDAR,
      COMMODITY_BUSINESS,
      CURRENCY_BUSINESS,
      EXCHANGE_BUSINESS,
      SCHEDULED_TRADING_DAY,
   }

   class FallbackReferencePrice : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FallbackReferencePrice";
      public SettlementRateOptionEnum[] fallBackSettlementRateOption { get; set; }
      public bool fallbackSurveyValuationPostponement { get; set; }
      public CalculationAgent calculationAgenDetermination { get; set; }
      public ValuationPostponement valuationPostponement { get; set; }
      public string fallBackSettlementRateOptionScheme { get; set; }
   }
   class FallbackReferencePriceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FallbackReferencePriceBuilder";
      public SettlementRateOptionEnum[] fallBackSettlementRateOption { get; set; }
      public bool fallbackSurveyValuationPostponement { get; set; }
      public string fallBackSettlementRateOptionScheme { get; set; }
   }
   class FixedIncomeSecurityBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FixedIncomeSecurityBuilder";
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class FixedIncomeSecurity : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FixedIncomeSecurity";
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class BasketName : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BasketName";
      public string basketName { get; set; }
      public string[] basketId { get; set; }
      public string basketIdScheme { get; set; }
      public string basketNameScheme { get; set; }
   }
   class BasketNameBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BasketNameBuilder";
      public string basketName { get; set; }
      public string[] basketId { get; set; }
      public string basketIdScheme { get; set; }
      public string basketNameScheme { get; set; }
   }
   enum QuotationSideEnum {
      BID,
      ASK,
      MID,
   }

   class TransferorTransfereeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TransferorTransfereeBuilder";
      public string transferorPartyReference { get; set; }
      public string transferorAccountReference { get; set; }
      public string transfereePartyReference { get; set; }
      public string transfereeAccountReference { get; set; }
   }
   class TransferorTransferee : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TransferorTransferee";
      public string transferorPartyReference { get; set; }
      public string transferorAccountReference { get; set; }
      public string transfereePartyReference { get; set; }
      public string transfereeAccountReference { get; set; }
   }
   class FutureValueAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FutureValueAmount";
      public DateTime valueDate { get; set; }
      public int calculationPeriodNumberOfDays { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class FutureValueAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FutureValueAmountBuilder";
      public DateTime valueDate { get; set; }
      public int calculationPeriodNumberOfDays { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   enum ObligationCategoryEnum {
      PAYMENT,
      BORROWED_MONEY,
      REFERENCE_OBLIGATIONS_ONLY,
      BOND,
      LOAN,
      BOND_OR_LOAN,
   }

   class PhysicalSettlementTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalSettlementTerms";
      public string id { get; set; }
      public DeliverableObligations deliverableObligations { get; set; }
      public string settlementCurrency { get; set; }
      public PhysicalSettlementPeriod physicalSettlementPeriod { get; set; }
      public bool escrow { get; set; }
      public bool sixtyBusinessDaySettlementCap { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class PhysicalSettlementTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalSettlementTermsBuilder";
      public string id { get; set; }
      public string settlementCurrency { get; set; }
      public bool escrow { get; set; }
      public bool sixtyBusinessDaySettlementCap { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class OptionalEarlyTerminationAdjustedDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionalEarlyTerminationAdjustedDates";
      public EarlyTerminationEvent[] earlyTerminationEvent { get; set; }
   }
   class OptionalEarlyTerminationAdjustedDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionalEarlyTerminationAdjustedDatesBuilder";
   }
   class OptionSettlement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionSettlement";
      public OptionPhysicalSettlement physicalSettlementTerms { get; set; }
      public string settlementCurrency { get; set; }
      public OptionCashSettlement cashSettlementTerms { get; set; }
      public SettlementTypeEnum settlementType { get; set; }
      public AdjustableOrRelativeDate settlementDate { get; set; }
      public Money settlementAmount { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class OptionSettlementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionSettlementBuilder";
      public string settlementCurrency { get; set; }
      public SettlementTypeEnum settlementType { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class OptionalEarlyTermination : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionalEarlyTermination";
      public OptionCashSettlement cashSettlement { get; set; }
      public bool followUpConfirmation { get; set; }
      public BuyerSeller singlePartyOption { get; set; }
      public AmericanExercise americanExercise { get; set; }
      public BermudaExercise bermudaExercise { get; set; }
      public EuropeanExercise europeanExercise { get; set; }
      public ExerciseNotice[] exerciseNotice { get; set; }
      public OptionalEarlyTerminationAdjustedDates optionalEarlyTerminationAdjustedDates { get; set; }
      public CalculationAgent calculationAgent { get; set; }
   }
   class OptionalEarlyTerminationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionalEarlyTerminationBuilder";
      public bool followUpConfirmation { get; set; }
   }
   class AssetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AssetBuilder";
   }
   class Asset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Asset";
      public Commodity commodity { get; set; }
      public ListedProduct listedProduct { get; set; }
   }
   enum StubPeriodTypeEnum {
      SHORT_INITIAL,
      SHORT_FINAL,
      LONG_INITIAL,
      LONG_FINAL,
   }

   class PartyContractInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyContractInformationBuilder";
      public string partyReference { get; set; }
   }
   class PartyContractInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyContractInformation";
      public NaturalPersonRole[] naturalPersonRole { get; set; }
      public string partyReference { get; set; }
   }
   class FxSpotRateSource : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxSpotRateSource";
      public InformationSource primaryRateSource { get; set; }
      public InformationSource secondaryRateSource { get; set; }
      public BusinessCenterTime fixingTime { get; set; }
   }
   class FxSpotRateSourceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxSpotRateSourceBuilder";
   }
   class SettlementRateSource : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettlementRateSource";
      public CashSettlementReferenceBanks cashSettlementReferenceBanks { get; set; }
      public InformationSource informationSource { get; set; }
   }
   class SettlementRateSourceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettlementRateSourceBuilder";
   }
   class CalculationPeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriodBuilder";
      public string id { get; set; }
      public float notionalAmount { get; set; }
      public float forecastRate { get; set; }
      public DateTime unadjustedStartDate { get; set; }
      public DateTime unadjustedEndDate { get; set; }
      public DateTime adjustedStartDate { get; set; }
      public DateTime adjustedEndDate { get; set; }
      public float dayCountYearFraction { get; set; }
      public int calculationPeriodNumberOfDays { get; set; }
      public float fixedRate { get; set; }
   }
   class CalculationPeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriod";
      public string id { get; set; }
      public float notionalAmount { get; set; }
      public float forecastRate { get; set; }
      public DateTime unadjustedStartDate { get; set; }
      public DateTime unadjustedEndDate { get; set; }
      public DateTime adjustedStartDate { get; set; }
      public DateTime adjustedEndDate { get; set; }
      public FxLinkedNotionalAmount fxLinkedNotionalAmount { get; set; }
      public FloatingRateDefinition floatingRateDefinition { get; set; }
      public float dayCountYearFraction { get; set; }
      public Money forecastAmount { get; set; }
      public int calculationPeriodNumberOfDays { get; set; }
      public float fixedRate { get; set; }
   }
   class ExecutionReferenceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExecutionReferenceBuilder";
      public StateEnum state { get; set; }
   }
   class ExecutionReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExecutionReference";
      public StateEnum state { get; set; }
      public Identifier executionReference { get; set; }
   }
   class ExerciseProcedure : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseProcedure";
      public ManualExercise manualExercise { get; set; }
      public AutomaticExercise automaticExercise { get; set; }
      public bool followUpConfirmation { get; set; }
      public bool limitedRightToConfirm { get; set; }
      public bool splitTicket { get; set; }
   }
   class ExerciseProcedureBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseProcedureBuilder";
      public bool followUpConfirmation { get; set; }
      public bool limitedRightToConfirm { get; set; }
      public bool splitTicket { get; set; }
   }
   enum CalculationAgentPartyEnum {
      EXERCISING_PARTY,
      NON_EXERCISING_PARTY,
      AS_SPECIFIED_IN_MASTER_AGREEMENT,
      AS_SPECIFIED_IN_STANDARD_TERMS_SUPPLEMENT,
      BOTH,
   }

   class NonNegativeSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeSchedule";
      public string id { get; set; }
      public float initialValue { get; set; }
      public NonNegativeStep[] step { get; set; }
   }
   class NonNegativeScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeScheduleBuilder";
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   class Contract : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Contract";
      public string id { get; set; }
      public StateEnum state { get; set; }
      public Account[] account { get; set; }
      public CalculationAgent calculationAgent { get; set; }
      public DateTime clearedDate { get; set; }
      public Collateral collateral { get; set; }
      public PartyContractIdentifier[] contractIdentifier { get; set; }
      public ContractualProduct contractualProduct { get; set; }
      public Documentation documentation { get; set; }
      public GoverningLawEnum governingLaw { get; set; }
      public string governingLawScheme { get; set; }
      public Payment[] otherPartyPayment { get; set; }
      public Party[] party { get; set; }
      public PartyContractInformation[] partyContractInformation { get; set; }
      public PartyRole[] partyRole { get; set; }
      public DateInstances tradeDate { get; set; }
      public string rosettaKey { get; set; }
   }
   class ContractBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractBuilder";
      public string id { get; set; }
      public StateEnum state { get; set; }
      public DateTime clearedDate { get; set; }
      public GoverningLawEnum governingLaw { get; set; }
      public string governingLawScheme { get; set; }
   }
   enum DiscountingTypeEnum {
      STANDARD,
      FRA,
      FRA_YIELD,
   }

   class Money : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Money";
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class MoneyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MoneyBuilder";
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class TriggerEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TriggerEvent";
      public DateList triggerDates { get; set; }
      public Trigger trigger { get; set; }
      public FeaturePayment featurePayment { get; set; }
      public AveragingSchedule[] schedule { get; set; }
   }
   class TriggerEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TriggerEventBuilder";
   }
   class ResetFrequencyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetFrequencyBuilder";
      public WeeklyRollConventionEnum weeklyRollConvention { get; set; }
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class ResetFrequency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResetFrequency";
      public WeeklyRollConventionEnum weeklyRollConvention { get; set; }
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   enum TriggerTypeEnum {
      EQUAL_OR_LESS,
      EQUAL_OR_GREATER,
      EQUAL,
      LESS,
      GREATER,
   }

   class CashSettlementReferenceBanks : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementReferenceBanks";
      public ReferenceBank[] referenceBank { get; set; }
   }
   class CashSettlementReferenceBanksBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementReferenceBanksBuilder";
   }
   class AssetPoolBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AssetPoolBuilder";
      public DateTime effectiveDate { get; set; }
      public float initialFactor { get; set; }
      public float currentFactor { get; set; }
      public string version { get; set; }
   }
   class AssetPool : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AssetPool";
      public DateTime effectiveDate { get; set; }
      public float initialFactor { get; set; }
      public float currentFactor { get; set; }
      public string version { get; set; }
   }
   class ContractualProductBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualProductBuilder";
   }
   class ContractualProduct : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualProduct";
      public EconomicTerms economicTerms { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public ProductIdentification productIdentification { get; set; }
   }
   class OptionPayoutBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionPayoutBuilder";
      public string id { get; set; }
      public OptionTypeEnum optionType { get; set; }
   }
   class OptionPayout : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionPayout";
      public string id { get; set; }
      public string rosettaKeyValue { get; set; }
      public BuyerSeller buyerSeller { get; set; }
      public OptionTypeEnum optionType { get; set; }
      public OptionFeature feature { get; set; }
      public OptionDenomination denomination { get; set; }
      public OptionExercise exerciseTerms { get; set; }
      public Product underlyer { get; set; }
      public ContractualQuantity quantity { get; set; }
   }
   class PayoutBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PayoutBuilder";
   }
   class Payout : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Payout";
      public Cashflow[] cashflow { get; set; }
      public OptionPayout[] optionPayout { get; set; }
      public CreditDefaultPayout creditDefaultPayout { get; set; }
      public InterestRatePayout[] interestRatePayout { get; set; }
   }
   class WeightedAveragingObservation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.WeightedAveragingObservation";
      public DateTime dateTime { get; set; }
      public float weight { get; set; }
      public int observationNumber { get; set; }
   }
   class WeightedAveragingObservationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.WeightedAveragingObservationBuilder";
      public DateTime dateTime { get; set; }
      public float weight { get; set; }
      public int observationNumber { get; set; }
   }
   class PubliclyAvailableInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PubliclyAvailableInformation";
      public int specifiedNumber { get; set; }
      public bool standardPublicSources { get; set; }
      public string[] publicSource { get; set; }
   }
   class PubliclyAvailableInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PubliclyAvailableInformationBuilder";
      public int specifiedNumber { get; set; }
      public bool standardPublicSources { get; set; }
      public string[] publicSource { get; set; }
   }
   class Party : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Party";
      public string id { get; set; }
      public string partyIdScheme { get; set; }
      public string[] partyId { get; set; }
      public LegalEntity legalEntity { get; set; }
      public NaturalPerson[] naturalPerson { get; set; }
   }
   class PartyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyBuilder";
      public string id { get; set; }
      public string partyIdScheme { get; set; }
      public string[] partyId { get; set; }
   }
   class MessageInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MessageInformationBuilder";
      public string copyToScheme { get; set; }
      public string messageIdScheme { get; set; }
      public string sentByScheme { get; set; }
      public string sentToScheme { get; set; }
      public string messageId { get; set; }
      public string sentBy { get; set; }
      public string sentTo { get; set; }
      public string[] copyTo { get; set; }
   }
   class MessageInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MessageInformation";
      public string copyToScheme { get; set; }
      public string messageIdScheme { get; set; }
      public string sentByScheme { get; set; }
      public string sentToScheme { get; set; }
      public string messageId { get; set; }
      public string sentBy { get; set; }
      public string sentTo { get; set; }
      public string[] copyTo { get; set; }
   }
   class Asian : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Asian";
      public AveragingInOutEnum averagingInOut { get; set; }
      public float strikeFactor { get; set; }
      public AveragingPeriod averagingPeriodIn { get; set; }
      public AveragingPeriod averagingPeriodOut { get; set; }
   }
   class AsianBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AsianBuilder";
      public AveragingInOutEnum averagingInOut { get; set; }
      public float strikeFactor { get; set; }
   }
   class ReferenceBankBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceBankBuilder";
      public string referenceBankId { get; set; }
      public string referenceBankName { get; set; }
      public string referenceBankIdScheme { get; set; }
   }
   class ReferenceBank : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceBank";
      public string referenceBankId { get; set; }
      public string referenceBankName { get; set; }
      public string referenceBankIdScheme { get; set; }
   }
   class ProtectionTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProtectionTerms";
      public string id { get; set; }
      public Money notionalAmount { get; set; }
      public CreditEvents creditEvents { get; set; }
      public FloatingAmountEvents floatingAmountEvents { get; set; }
      public Obligations obligations { get; set; }
   }
   class ProtectionTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProtectionTermsBuilder";
      public string id { get; set; }
   }
   enum ProductIdSourceEnum {
      CUSIP,
      SEDOL,
      ISIN,
      RIC,
      FIGI,
      WERTPAPIER,
      SICOVAM,
   }

   class RestructuringBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RestructuringBuilder";
      public bool multipleHolderObligation { get; set; }
      public bool multipleCreditEventNotices { get; set; }
      public bool applicable { get; set; }
      public RestructuringEnum restructuringType { get; set; }
      public string restructuringTypeScheme { get; set; }
   }
   class Restructuring : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Restructuring";
      public bool multipleHolderObligation { get; set; }
      public bool multipleCreditEventNotices { get; set; }
      public bool applicable { get; set; }
      public RestructuringEnum restructuringType { get; set; }
      public string restructuringTypeScheme { get; set; }
   }
   class CreditEventNotice : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditEventNotice";
      public NotifyingParty notifyingParty { get; set; }
      public BusinessCenterEnum businessCenter { get; set; }
      public PubliclyAvailableInformation publiclyAvailableInformation { get; set; }
   }
   class CreditEventNoticeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditEventNoticeBuilder";
      public BusinessCenterEnum businessCenter { get; set; }
   }
   class StrikeSpread : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrikeSpread";
      public OptionStrike upperStrike { get; set; }
      public float upperStrikeNumberOfOptions { get; set; }
   }
   class StrikeSpreadBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StrikeSpreadBuilder";
      public float upperStrikeNumberOfOptions { get; set; }
   }
   class ResourceLength : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResourceLength";
      public LengthUnitEnum lengthUnit { get; set; }
      public float lengthValue { get; set; }
   }
   class ResourceLengthBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResourceLengthBuilder";
      public LengthUnitEnum lengthUnit { get; set; }
      public float lengthValue { get; set; }
   }
   enum ResourceTypeEnum {
      CONFIRMATION,
      SUPPLEMENTAL_MATERIAL_ECONOMIC_TERMS,
      TERM_SHEET,
   }

   class AmericanExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AmericanExerciseBuilder";
      public string id { get; set; }
   }
   class AmericanExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AmericanExercise";
      public string id { get; set; }
      public AdjustableOrRelativeDate expirationDate { get; set; }
      public AdjustableOrRelativeDates relevantUnderlyingDate { get; set; }
      public BusinessCenterTime earliestExerciseTime { get; set; }
      public BusinessCenterTime expirationTime { get; set; }
      public BusinessCenterTime latestExerciseTime { get; set; }
      public MultipleExercise multipleExercise { get; set; }
      public ExerciseFeeSchedule exerciseFeeSchedule { get; set; }
      public AdjustableOrRelativeDate commencementDate { get; set; }
   }
   enum CouponTypeEnum {
      FIXED,
      FLOAT,
      STRUCTURED,
   }

   enum SettlementTypeEnum {
      CASH,
      PHYSICAL,
      ELECTION,
      CASH_OR_PHYSICAL,
   }

   class CreditEvents : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditEvents";
      public string id { get; set; }
      public CreditEventNotice creditEventNotice { get; set; }
      public Restructuring restructuring { get; set; }
      public bool failureToPayPrincipal { get; set; }
      public bool failureToPayInterest { get; set; }
      public bool distressedRatingsDowngrade { get; set; }
      public bool maturityExtension { get; set; }
      public bool writedown { get; set; }
      public bool impliedWritedown { get; set; }
      public bool bankruptcy { get; set; }
      public bool obligationDefault { get; set; }
      public bool obligationAcceleration { get; set; }
      public bool repudiationMoratorium { get; set; }
      public bool governmentalIntervention { get; set; }
      public FailureToPay failureToPay { get; set; }
      public Money defaultRequirement { get; set; }
   }
   class CreditEventsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CreditEventsBuilder";
      public string id { get; set; }
      public bool failureToPayPrincipal { get; set; }
      public bool failureToPayInterest { get; set; }
      public bool distressedRatingsDowngrade { get; set; }
      public bool maturityExtension { get; set; }
      public bool writedown { get; set; }
      public bool impliedWritedown { get; set; }
      public bool bankruptcy { get; set; }
      public bool obligationDefault { get; set; }
      public bool obligationAcceleration { get; set; }
      public bool repudiationMoratorium { get; set; }
      public bool governmentalIntervention { get; set; }
   }
   class NotifyingParty : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotifyingParty";
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
   }
   class NotifyingPartyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotifyingPartyBuilder";
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
   }
   class IndependentAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IndependentAmount";
      public PaymentDetail[] paymentDetail { get; set; }
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   class IndependentAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IndependentAmountBuilder";
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   class ContractIdentifierBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractIdentifierBuilder";
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class ContractIdentifier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractIdentifier";
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public IdentifierValue identifierValue { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class ContractualQuantityBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualQuantityBuilder";
      public string notionalReference { get; set; }
   }
   class ContractualQuantity : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualQuantity";
      public Money notionalAmount { get; set; }
      public NotionalSchedule notionalSchedule { get; set; }
      public FxLinkedNotionalSchedule fxLinkedNotional { get; set; }
      public string notionalReference { get; set; }
      public Quantity quantity { get; set; }
      public FutureValueAmount futureValueNotional { get; set; }
   }
   class DateRelativeToPaymentDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRelativeToPaymentDates";
      public string[] paymentDatesReference { get; set; }
   }
   class DateRelativeToPaymentDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRelativeToPaymentDatesBuilder";
      public string[] paymentDatesReference { get; set; }
   }
   class PaymentCalculationPeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentCalculationPeriod";
      public string id { get; set; }
      public DateTime unadjustedPaymentDate { get; set; }
      public DateTime adjustedPaymentDate { get; set; }
      public float fixedPaymentAmount { get; set; }
      public float discountFactor { get; set; }
      public Money forecastPaymentAmount { get; set; }
      public Money presentValueAmount { get; set; }
      public CalculationPeriod[] calculationPeriod { get; set; }
   }
   class PaymentCalculationPeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PaymentCalculationPeriodBuilder";
      public string id { get; set; }
      public DateTime unadjustedPaymentDate { get; set; }
      public DateTime adjustedPaymentDate { get; set; }
      public float fixedPaymentAmount { get; set; }
      public float discountFactor { get; set; }
   }
   class PartialExercise : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartialExercise";
      public int minimumNumberOfOptions { get; set; }
      public string notionaReference { get; set; }
      public float integralMultipleAmount { get; set; }
      public float minimumNotionalAmount { get; set; }
   }
   class PartialExerciseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartialExerciseBuilder";
      public int minimumNumberOfOptions { get; set; }
      public string notionaReference { get; set; }
      public float integralMultipleAmount { get; set; }
      public float minimumNotionalAmount { get; set; }
   }
   enum MortgageSectorEnum {
      ABS,
      CDO,
      CMBS,
      RMBS,
   }

   class CrossCurrencyTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CrossCurrencyTerms";
      public SettlementProvision settlementProvision { get; set; }
      public PrincipalExchanges principalExchanges { get; set; }
   }
   class CrossCurrencyTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CrossCurrencyTermsBuilder";
   }
   enum PartyIdSourceEnum {
      BIC,
      LEI,
      ARNU,
      CCPT,
      CUST,
      DRLC,
      EMPL,
      NIDN,
      SOSE,
      TXID,
   }

   class IssuerTradeId : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IssuerTradeId";
      public string identifier { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public string identifierScheme { get; set; }
   }
   class IssuerTradeIdBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IssuerTradeIdBuilder";
      public string identifier { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public string identifierScheme { get; set; }
   }
   class IdentifierBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IdentifierBuilder";
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class Identifier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Identifier";
      public IdentifierValue identifierValue { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class FrequencyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FrequencyBuilder";
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class Frequency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Frequency";
      public string id { get; set; }
      public PeriodExtendedEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class PassThroughItem : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PassThroughItem";
      public float passThroughPercentage { get; set; }
      public PayerReceiver payerReceiver { get; set; }
   }
   class PassThroughItemBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PassThroughItemBuilder";
      public float passThroughPercentage { get; set; }
   }
   class OtherAgreementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OtherAgreementBuilder";
      public string type { get; set; }
      public string identifier { get; set; }
      public string identifierScheme { get; set; }
      public DateTime date { get; set; }
      public string typeScheme { get; set; }
      public string versionScheme { get; set; }
      public string version { get; set; }
   }
   class OtherAgreement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OtherAgreement";
      public string type { get; set; }
      public string identifier { get; set; }
      public string identifierScheme { get; set; }
      public DateTime date { get; set; }
      public string typeScheme { get; set; }
      public string versionScheme { get; set; }
      public string version { get; set; }
   }
   enum ContractualSupplementEnum {
      ABX,
      CD_SON_MBS,
      ISDA_1999_CREDIT_CONVERTIBLE_EXCHANGEABLE_ACCRETING_OBLIGATIONS,
      ISDA_1999_CREDIT_SUCCESSOR_AND_CREDIT_EVENTS,
      ISDA_2003_CREDIT_MAY_2003,
      I_TRAXX_EUROPE_DEALER,
      STANDARD_LCDS,
   }

   enum TaxonomySourceEnum {
      CFI,
      ISDA,
   }

   class FailureToPay : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FailureToPay";
      public bool applicable { get; set; }
      public GracePeriodExtension gracePeriodExtension { get; set; }
      public Money paymentRequirement { get; set; }
   }
   class FailureToPayBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FailureToPayBuilder";
      public bool applicable { get; set; }
   }
   enum PayRelativeToEnum {
      CALCULATION_PERIOD_START_DATE,
      CALCULATION_PERIOD_END_DATE,
      LAST_PRICING_DATE,
      RESET_DATE,
      VALUATION_DATE,
   }

   class ExerciseEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseEventBuilder";
      public string id { get; set; }
      public DateTime adjustedRelevantSwapEffectiveDate { get; set; }
      public DateTime adjustedExerciseFeePaymentDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class ExerciseEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseEvent";
      public string id { get; set; }
      public DateTime adjustedRelevantSwapEffectiveDate { get; set; }
      public DateTime adjustedExerciseFeePaymentDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class SpreadSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SpreadSchedule";
      public SpreadScheduleTypeEnum type { get; set; }
      public string typeScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
      public Step[] step { get; set; }
   }
   class SpreadScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SpreadScheduleBuilder";
      public SpreadScheduleTypeEnum type { get; set; }
      public string typeScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   class LoanParticipation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LoanParticipation";
      public string qualifyingParticipationSeller { get; set; }
      public bool applicable { get; set; }
      public bool partialCashSettlement { get; set; }
   }
   class LoanParticipationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LoanParticipationBuilder";
      public string qualifyingParticipationSeller { get; set; }
      public bool applicable { get; set; }
      public bool partialCashSettlement { get; set; }
   }
   class IdentifierValueBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IdentifierValueBuilder";
      public string id { get; set; }
      public string identifier { get; set; }
      public string identifierScheme { get; set; }
   }
   class IdentifierValue : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IdentifierValue";
      public string id { get; set; }
      public string identifier { get; set; }
      public string identifierScheme { get; set; }
   }
   class Loan : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Loan";
      public string facilityTypeScheme { get; set; }
      public string lienScheme { get; set; }
      public string trancheScheme { get; set; }
      public string tranche { get; set; }
      public DateTime maturity { get; set; }
      public LegalEntity[] borrower { get; set; }
      public string[] borrowerReference { get; set; }
      public string lien { get; set; }
      public string facilityType { get; set; }
      public DateTime creditAgreementDate { get; set; }
      public string id { get; set; }
      public string instrumentIdentifierScheme { get; set; }
      public string description { get; set; }
      public string[] instrumentIdentifier { get; set; }
   }
   class LoanBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LoanBuilder";
      public string facilityTypeScheme { get; set; }
      public string lienScheme { get; set; }
      public string trancheScheme { get; set; }
      public string tranche { get; set; }
      public DateTime maturity { get; set; }
      public string[] borrowerReference { get; set; }
      public string lien { get; set; }
      public string facilityType { get; set; }
      public DateTime creditAgreementDate { get; set; }
      public string id { get; set; }
      public string instrumentIdentifierScheme { get; set; }
      public string description { get; set; }
      public string[] instrumentIdentifier { get; set; }
   }
   class EventEffect : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventEffect";
      public string[] listedProduct { get; set; }
      public string[] payment { get; set; }
      public string[] contractReference { get; set; }
      public string[] effectedContract { get; set; }
      public string[] effectedContractReference { get; set; }
      public string effectedEvent { get; set; }
      public string[] transfer { get; set; }
      public string[] contract { get; set; }
   }
   class EventEffectBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventEffectBuilder";
      public string[] listedProduct { get; set; }
      public string[] payment { get; set; }
      public string[] contractReference { get; set; }
      public string[] effectedContract { get; set; }
      public string[] effectedContractReference { get; set; }
      public string effectedEvent { get; set; }
      public string[] transfer { get; set; }
      public string[] contract { get; set; }
   }
   class BusinessCentersBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessCentersBuilder";
      public string id { get; set; }
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum[] businessCenter { get; set; }
      public string businessCentersReference { get; set; }
   }
   class BusinessCenters : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessCenters";
      public string id { get; set; }
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum[] businessCenter { get; set; }
      public string businessCentersReference { get; set; }
   }
   class BondOptionStrikeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BondOptionStrikeBuilder";
   }
   class BondOptionStrike : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BondOptionStrike";
      public ReferenceSwapCurve referenceSwapCurve { get; set; }
      public OptionStrike price { get; set; }
   }
   class MandatoryEarlyTerminationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MandatoryEarlyTerminationBuilder";
      public string id { get; set; }
   }
   class MandatoryEarlyTermination : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MandatoryEarlyTermination";
      public string id { get; set; }
      public OptionCashSettlement cashSettlement { get; set; }
      public CalculationAgent calculationAgent { get; set; }
      public AdjustableDate mandatoryEarlyTerminationDate { get; set; }
      public MandatoryEarlyTerminationAdjustedDates mandatoryEarlyTerminationAdjustedDates { get; set; }
   }
   class OptionStyleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionStyleBuilder";
   }
   class OptionStyle : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionStyle";
      public AmericanExercise americanExercise { get; set; }
      public BermudaExercise bermudaExercise { get; set; }
      public EuropeanExercise europeanExercise { get; set; }
   }
   class ProductIdentifierBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductIdentifierBuilder";
      public string productId { get; set; }
      public ProductIdSourceEnum productIdSource { get; set; }
      public string productIdScheme { get; set; }
   }
   class ProductIdentifier : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductIdentifier";
      public string productId { get; set; }
      public ProductIdSourceEnum productIdSource { get; set; }
      public string productIdScheme { get; set; }
   }
   class SpecifiedCurrencyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SpecifiedCurrencyBuilder";
      public string currency { get; set; }
      public bool applicable { get; set; }
      public string currencyScheme { get; set; }
   }
   class SpecifiedCurrency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SpecifiedCurrency";
      public string currency { get; set; }
      public bool applicable { get; set; }
      public string currencyScheme { get; set; }
   }
   class CalculationPeriodDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriodDates";
      public string id { get; set; }
      public CalculationPeriodFrequency calculationPeriodFrequency { get; set; }
      public DateInstances effectiveDate { get; set; }
      public AdjustableDate terminationDate { get; set; }
      public DateTime firstCompoundingPeriodEndDate { get; set; }
      public StubPeriodTypeEnum stubPeriodType { get; set; }
      public AdjustedRelativeDateOffset relativeEffectiveDate { get; set; }
      public RelativeDateOffset relativeTerminationDate { get; set; }
      public AdjustableDate firstPeriodStartDate { get; set; }
      public DateTime firstRegularPeriodStartDate { get; set; }
      public BusinessDayAdjustments calculationPeriodDatesAdjustments { get; set; }
      public DateTime lastRegularPeriodEndDate { get; set; }
   }
   class CalculationPeriodDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationPeriodDatesBuilder";
      public string id { get; set; }
      public DateTime firstCompoundingPeriodEndDate { get; set; }
      public StubPeriodTypeEnum stubPeriodType { get; set; }
      public DateTime firstRegularPeriodStartDate { get; set; }
      public DateTime lastRegularPeriodEndDate { get; set; }
   }
   class StubCalculationPeriodAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubCalculationPeriodAmount";
      public string calculationPeriodDatesReference { get; set; }
      public StubValue initialStub { get; set; }
      public StubValue finalStub { get; set; }
   }
   class StubCalculationPeriodAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubCalculationPeriodAmountBuilder";
      public string calculationPeriodDatesReference { get; set; }
   }
   enum SettledEntityMatrixSourceEnum {
      CONFIRMATION_ANNEX,
      NOT_APPLICABLE,
      PUBLISHER,
   }

   class SwapCurveValuation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SwapCurveValuation";
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public float spread { get; set; }
      public QuotationSideEnum side { get; set; }
   }
   class SwapCurveValuationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SwapCurveValuationBuilder";
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public float spread { get; set; }
      public QuotationSideEnum side { get; set; }
   }
   class PartyAndAccountReferenceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyAndAccountReferenceBuilder";
      public string accountReference { get; set; }
      public string partyReference { get; set; }
   }
   class PartyAndAccountReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PartyAndAccountReference";
      public string accountReference { get; set; }
      public string partyReference { get; set; }
   }
   class ConstituentWeightBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ConstituentWeightBuilder";
      public float openUnits { get; set; }
      public float basketPercentage { get; set; }
   }
   class ConstituentWeight : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ConstituentWeight";
      public float openUnits { get; set; }
      public float basketPercentage { get; set; }
   }
   class InterestRatePayoutBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRatePayoutBuilder";
      public string id { get; set; }
      public string dayCountFractionScheme { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public CompoundingMethodEnum compoundingMethod { get; set; }
   }
   class InterestRatePayout : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InterestRatePayout";
      public string id { get; set; }
      public string rosettaKeyValue { get; set; }
      public string dayCountFractionScheme { get; set; }
      public CrossCurrencyTerms crossCurrencyTerms { get; set; }
      public Discounting discounting { get; set; }
      public CashflowRepresentation cashflowRepresentation { get; set; }
      public BondReference bondReference { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public CompoundingMethodEnum compoundingMethod { get; set; }
      public ResetDates resetDates { get; set; }
      public PayerReceiver payerReceiver { get; set; }
      public CalculationPeriodDates calculationPeriodDates { get; set; }
      public ContractualQuantity quantity { get; set; }
      public InterestRate interestRate { get; set; }
      public StubPeriod stubPeriod { get; set; }
      public PaymentDates paymentDates { get; set; }
   }
   class AdjustableOrAdjustedOrRelativeDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrAdjustedOrRelativeDateBuilder";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public DateTime adjustedDate { get; set; }
   }
   class AdjustableOrAdjustedOrRelativeDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrAdjustedOrRelativeDate";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public RelativeDateOffset relativeDate { get; set; }
      public DateTime adjustedDate { get; set; }
      public BusinessDayAdjustments dateAdjustments { get; set; }
   }
   class Obligations : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Obligations";
      public ObligationCategoryEnum category { get; set; }
      public string excluded { get; set; }
      public bool fullFaithAndCreditObLiability { get; set; }
      public bool generalFundObligationLiability { get; set; }
      public bool listed { get; set; }
      public bool notContingent { get; set; }
      public NotDomesticCurrency notDomesticCurrency { get; set; }
      public bool notDomesticIssuance { get; set; }
      public bool notDomesticLaw { get; set; }
      public bool notSovereignLender { get; set; }
      public bool notSubordinated { get; set; }
      public string othReferenceEntityObligations { get; set; }
      public bool revenueObligationLiability { get; set; }
      public SpecifiedCurrency specifiedCurrency { get; set; }
      public string designatedPriority { get; set; }
      public bool cashSettlementOnly { get; set; }
      public bool deliveryOfCommitments { get; set; }
      public bool continuity { get; set; }
      public string designatedPriorityScheme { get; set; }
   }
   class ObligationsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ObligationsBuilder";
      public ObligationCategoryEnum category { get; set; }
      public string excluded { get; set; }
      public bool fullFaithAndCreditObLiability { get; set; }
      public bool generalFundObligationLiability { get; set; }
      public bool listed { get; set; }
      public bool notContingent { get; set; }
      public bool notDomesticIssuance { get; set; }
      public bool notDomesticLaw { get; set; }
      public bool notSovereignLender { get; set; }
      public bool notSubordinated { get; set; }
      public string othReferenceEntityObligations { get; set; }
      public bool revenueObligationLiability { get; set; }
      public string designatedPriority { get; set; }
      public bool cashSettlementOnly { get; set; }
      public bool deliveryOfCommitments { get; set; }
      public bool continuity { get; set; }
      public string designatedPriorityScheme { get; set; }
   }
   class ContractualTermsSupplement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualTermsSupplement";
      public ContractualSupplementEnum type { get; set; }
      public DateTime publicationDate { get; set; }
      public string typeScheme { get; set; }
   }
   class ContractualTermsSupplementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractualTermsSupplementBuilder";
      public ContractualSupplementEnum type { get; set; }
      public DateTime publicationDate { get; set; }
      public string typeScheme { get; set; }
   }
   class Lineage : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Lineage";
      public Identifier[] contractReference { get; set; }
      public Identifier[] eventReference { get; set; }
      public string contractReferenceScheme { get; set; }
   }
   class LineageBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LineageBuilder";
      public string contractReferenceScheme { get; set; }
   }
   class SettledEntityMatrix : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettledEntityMatrix";
      public DateTime publicationDate { get; set; }
      public string matrixSourceScheme { get; set; }
      public SettledEntityMatrixSourceEnum matrixSource { get; set; }
   }
   class SettledEntityMatrixBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettledEntityMatrixBuilder";
      public DateTime publicationDate { get; set; }
      public string matrixSourceScheme { get; set; }
      public SettledEntityMatrixSourceEnum matrixSource { get; set; }
   }
   class ReferenceInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceInformationBuilder";
      public float referencePrice { get; set; }
      public bool allGuarantees { get; set; }
      public bool noReferenceObligation { get; set; }
      public bool unknownReferenceObligation { get; set; }
      public bool referencePolicy { get; set; }
      public bool securedList { get; set; }
   }
   class ReferenceInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceInformation";
      public float referencePrice { get; set; }
      public bool allGuarantees { get; set; }
      public ReferenceObligation[] referenceObligation { get; set; }
      public LegalEntity referenceEntity { get; set; }
      public bool noReferenceObligation { get; set; }
      public bool unknownReferenceObligation { get; set; }
      public bool referencePolicy { get; set; }
      public bool securedList { get; set; }
   }
   class NonNegativeAmountScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeAmountScheduleBuilder";
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   class NonNegativeAmountSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NonNegativeAmountSchedule";
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public string id { get; set; }
      public float initialValue { get; set; }
      public NonNegativeStep[] step { get; set; }
   }
   enum CashflowTypeEnum {
      BROKERAGE_COMMISSION,
      FEE,
      INTEREST,
      NET_INTEREST,
      NOVATION_FEE,
      PREMIUM,
      TERMINATION_FEE,
   }

   class PayerReceiver : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PayerReceiver";
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   class PayerReceiverBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PayerReceiverBuilder";
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   enum BusinessCenterEnum {
      AEAD,
      AEDU,
      AMYE,
      BEBR,
      BRBD,
      CATO,
      CHZU,
      CNBE,
      DEFR,
      EUTA,
      GBLO,
      INMU,
      JPTO,
      KRSE,
      USNY,
   }

   class BasketReferenceInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BasketReferenceInformation";
      public Tranche tranche { get; set; }
      public BasketName basketName { get; set; }
      public string[] basketId { get; set; }
      public ReferencePool referencePool { get; set; }
      public int nthToDefault { get; set; }
      public int mthToDefault { get; set; }
      public string basketIdScheme { get; set; }
   }
   class BasketReferenceInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BasketReferenceInformationBuilder";
      public string[] basketId { get; set; }
      public int nthToDefault { get; set; }
      public int mthToDefault { get; set; }
      public string basketIdScheme { get; set; }
   }
   class FeaturePayment : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FeaturePayment";
      public string id { get; set; }
      public string currency { get; set; }
      public AdjustableOrAdjustedDate featurePaymentDate { get; set; }
      public string currencyScheme { get; set; }
      public float levelPercentage { get; set; }
      public PayerReceiver payerReceiver { get; set; }
      public float amount { get; set; }
      public TimeTypeEnum time { get; set; }
   }
   class FeaturePaymentBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FeaturePaymentBuilder";
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float levelPercentage { get; set; }
      public float amount { get; set; }
      public TimeTypeEnum time { get; set; }
   }
   class ReferencePool : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePool";
      public ReferencePoolItem[] referencePoolItem { get; set; }
   }
   class ReferencePoolBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePoolBuilder";
   }
   class PhysicalSettlementPeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalSettlementPeriod";
      public int businessDays { get; set; }
      public int maximumBusinessDays { get; set; }
      public bool businessDaysNotSpecified { get; set; }
   }
   class PhysicalSettlementPeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PhysicalSettlementPeriodBuilder";
      public int businessDays { get; set; }
      public int maximumBusinessDays { get; set; }
      public bool businessDaysNotSpecified { get; set; }
   }
   enum PackageTypeEnum {
      BUTTERFLY,
      CALENDAR_ROLL,
      CALENDAR_SPREAD,
      CUSTOM,
      INDEX_ROLL,
      ONE_CANCELS_OTHERS,
      SWAP_SPREAD,
      SWITCH,
   }

   class EconomicTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EconomicTermsBuilder";
   }
   class EconomicTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EconomicTerms";
      public string rosettaKeyValue { get; set; }
      public Payout payout { get; set; }
      public EarlyTerminationProvision earlyTerminationProvision { get; set; }
      public CancelableProvision cancelableProvision { get; set; }
      public ExtendibleProvision extendibleProvision { get; set; }
   }
   class EquityAsset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EquityAsset";
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class EquityAssetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EquityAssetBuilder";
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class AdjustableOrRelativeDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrRelativeDates";
      public string id { get; set; }
      public AdjustableDates adjustableDates { get; set; }
      public RelativeDates relativeDates { get; set; }
   }
   class AdjustableOrRelativeDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableOrRelativeDatesBuilder";
      public string id { get; set; }
   }
   enum IndexAnnexSourceEnum {
      MASTER_CONFIRMATION,
      PUBLISHER,
   }

   class Knock : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Knock";
      public TriggerEvent knockOut { get; set; }
      public TriggerEvent knockIn { get; set; }
   }
   class KnockBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.KnockBuilder";
   }
   class CalculationAgentModelBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAgentModelBuilder";
      public BusinessCenterEnum calculationAgentBusinessCenter { get; set; }
   }
   class CalculationAgentModel : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAgentModel";
      public BusinessCenterEnum calculationAgentBusinessCenter { get; set; }
      public CalculationAgent calculationAgent { get; set; }
   }
   class CalendarSpread : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalendarSpread";
      public AdjustableOrRelativeDate expirationDateTwo { get; set; }
   }
   class CalendarSpreadBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalendarSpreadBuilder";
   }
   class ProductTaxonomy : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductTaxonomy";
      public string taxonomyValue { get; set; }
      public TaxonomySourceEnum taxonomySource { get; set; }
   }
   class ProductTaxonomyBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductTaxonomyBuilder";
      public string taxonomyValue { get; set; }
      public TaxonomySourceEnum taxonomySource { get; set; }
   }
   enum TransferTypeEnum {
      SECURITY_SETTLEMENT,
      SECURITY_TRANSFER,
      BROKERAGE_COMMISSION,
      FEE,
      INTEREST,
      NET_INTEREST,
      NOVATION_FEE,
      PREMIUM,
      TERMINATION_FEE,
   }

   class BrokerConfirmation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BrokerConfirmation";
      public BrokerConfirmationTypeEnum brokerConfirmationType { get; set; }
      public string brokerConfirmationTypeScheme { get; set; }
   }
   class BrokerConfirmationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BrokerConfirmationBuilder";
      public BrokerConfirmationTypeEnum brokerConfirmationType { get; set; }
      public string brokerConfirmationTypeScheme { get; set; }
   }
   class DeliverableObligations : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DeliverableObligations";
      public ObligationCategoryEnum category { get; set; }
      public bool acceleratedOrMatured { get; set; }
      public bool accruedInterest { get; set; }
      public PCDeliverableObligationCharac assignableLoan { get; set; }
      public PCDeliverableObligationCharac consentRequiredLoan { get; set; }
      public LoanParticipation directLoanParticipation { get; set; }
      public string excluded { get; set; }
      public bool fullFaithAndCreditObLiability { get; set; }
      public bool generalFundObligationLiability { get; set; }
      public LoanParticipation indirectLoanParticipation { get; set; }
      public bool listed { get; set; }
      public Period maximumMaturity { get; set; }
      public bool notBearer { get; set; }
      public bool notContingent { get; set; }
      public NotDomesticCurrency notDomesticCurrency { get; set; }
      public bool notDomesticIssuance { get; set; }
      public bool notDomesticLaw { get; set; }
      public bool notSovereignLender { get; set; }
      public bool notSubordinated { get; set; }
      public string othReferenceEntityObligations { get; set; }
      public bool revenueObligationLiability { get; set; }
      public SpecifiedCurrency specifiedCurrency { get; set; }
      public bool transferable { get; set; }
   }
   class DeliverableObligationsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DeliverableObligationsBuilder";
      public ObligationCategoryEnum category { get; set; }
      public bool acceleratedOrMatured { get; set; }
      public bool accruedInterest { get; set; }
      public string excluded { get; set; }
      public bool fullFaithAndCreditObLiability { get; set; }
      public bool generalFundObligationLiability { get; set; }
      public bool listed { get; set; }
      public bool notBearer { get; set; }
      public bool notContingent { get; set; }
      public bool notDomesticIssuance { get; set; }
      public bool notDomesticLaw { get; set; }
      public bool notSovereignLender { get; set; }
      public bool notSubordinated { get; set; }
      public string othReferenceEntityObligations { get; set; }
      public bool revenueObligationLiability { get; set; }
      public bool transferable { get; set; }
   }
   class DateInstancesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateInstancesBuilder";
      public string id { get; set; }
      public DateTime date { get; set; }
   }
   class DateInstances : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateInstances";
      public string id { get; set; }
      public AdjustableDate adjustableDate { get; set; }
      public PriorDateInstance[] priorDateInstance { get; set; }
      public DateTime date { get; set; }
   }
   class ExerciseNoticeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseNoticeBuilder";
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum businessCenter { get; set; }
      public string exerciseNoticePartyReference { get; set; }
      public string partyReference { get; set; }
   }
   class ExerciseNotice : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseNotice";
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum businessCenter { get; set; }
      public string exerciseNoticePartyReference { get; set; }
      public string partyReference { get; set; }
   }
   enum MasterAgreementTypeEnum {
      AFB,
      ISDA,
   }

   class FloatingRate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRate";
      public string id { get; set; }
      public SpreadSchedule[] spreadSchedule { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public Schedule floatingRateMultiplierSchedule { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
      public StrikeSchedule[] capRateSchedule { get; set; }
      public StrikeSchedule[] floorRateSchedule { get; set; }
   }
   class FloatingRateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FloatingRateBuilder";
      public string id { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
   }
   class CancellationEvent : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancellationEvent";
      public string id { get; set; }
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class CancellationEventBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancellationEventBuilder";
      public string id { get; set; }
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedExerciseDate { get; set; }
   }
   class MultipleValuationDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MultipleValuationDates";
      public int businessDaysThereafter { get; set; }
      public int numberValuationDates { get; set; }
      public int businessDays { get; set; }
   }
   class MultipleValuationDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MultipleValuationDatesBuilder";
      public int businessDaysThereafter { get; set; }
      public int numberValuationDates { get; set; }
      public int businessDays { get; set; }
   }
   class TriggerBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TriggerBuilder";
      public float level { get; set; }
      public float levelPercentage { get; set; }
      public string creditEventsReference { get; set; }
      public TriggerTypeEnum triggerType { get; set; }
      public TriggerTimeTypeEnum triggerTimeType { get; set; }
   }
   class Trigger : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Trigger";
      public CreditEvents creditEvents { get; set; }
      public float level { get; set; }
      public float levelPercentage { get; set; }
      public string creditEventsReference { get; set; }
      public TriggerTypeEnum triggerType { get; set; }
      public TriggerTimeTypeEnum triggerTimeType { get; set; }
   }
   class ExerciseOutcome : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseOutcome";
      public PhysicalExercise physicalExercise { get; set; }
      public Cashflow cashExercise { get; set; }
      public ContractReference[] contractReference { get; set; }
      public Contract[] contract { get; set; }
   }
   class ExerciseOutcomeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseOutcomeBuilder";
   }
   class ExerciseFeeScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseFeeScheduleBuilder";
      public string notionalReference { get; set; }
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   class ExerciseFeeSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseFeeSchedule";
      public string notionalReference { get; set; }
      public AmountSchedule feeAmountSchedule { get; set; }
      public Schedule feeRateSchedule { get; set; }
      public RelativeDateOffset feePaymentDate { get; set; }
      public string payerPartyReference { get; set; }
      public string receiverPartyReference { get; set; }
      public string payerAccountReference { get; set; }
      public string receiverAccountReference { get; set; }
   }
   enum MarketDisruptionEnum {
      MODIFIED_POSTPONEMENT,
      OMISSION,
      POSTPONEMENT,
   }

   enum FloatingRateIndexEnum {
      AED_EBOR_REUTERS,
      AUD_AONIA_OIS_COMPOUND,
      AUD_AONIA_OIS_COMPOUND_SWAP_MARKER,
      BRL_CDI,
      CAD_BA_CDOR,
      CNY_CNREPOFIX_CFXS_REUTERS,
      EUR_EONIA_OIS_COMPOUND,
      EUR_EURIBOR_REUTERS,
      EUR_EURIBOR_TELERATE,
      EUR_LIBOR_BBA,
      GBP_LIBOR_BBA,
      GBP_LIBOR_ISDA,
      GBP_SONIA_COMPOUND,
      INR_FBIL_MIBOR_OIS_COMPOUND,
      KRW_CD_KSDA_BLOOMBERG,
      UK_RPIX,
      USA_CPI_U,
      USD_FEDERAL_FUNDS_H_15_OIS_COMPOUND,
      USD_LIBOR_BBA,
   }

   class EventTimestamp : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventTimestamp";
      public DateTime expiryTimestamp { get; set; }
      public DateTime creationTimestamp { get; set; }
   }
   class EventTimestampBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EventTimestampBuilder";
      public DateTime expiryTimestamp { get; set; }
      public DateTime creationTimestamp { get; set; }
   }
   class QuantoBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuantoBuilder";
   }
   class Quanto : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Quanto";
      public FxRate[] fxRate { get; set; }
      public FxSpotRateSource fxSpotRateSource { get; set; }
   }
   enum UnitEnum {
      M_WH,
      MMBTU,
      BBL,
      GAL,
      BSH,
   }

   enum DeterminationMethodEnum {
      AGREED_INITIAL_PRICE,
      AS_SPECIFIED_IN_MASTER_CONFIRMATION,
      CALCULATION_AGENT,
      CLOSING_PRICE,
      DIVIDEND_CURRENCY,
      EXPIRING_CONTRACT_LEVEL,
      HEDGE_EXECUTION,
      ISSUER_PAYMENT_CURRENCY,
      NAV,
      OPEN_PRICE,
      OSP_PRICE,
      SETTLEMENT_CURRENCY,
      STRIKE_DATE_DETERMINATION,
      TWAP_PRICE,
      VALUATION_TIME,
      VWAP_PRICE,
   }

   class NotionalSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotionalSchedule";
      public string id { get; set; }
      public NonNegativeAmountSchedule notionalStepSchedule { get; set; }
      public NotionalStepRule notionalStepParameters { get; set; }
   }
   class NotionalScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotionalScheduleBuilder";
      public string id { get; set; }
   }
   enum PeriodEnum {
      D,
      W,
      M,
      Y,
   }

   class InceptionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InceptionBuilder";
   }
   class Inception : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Inception";
      public ContractOrContractReference[] before { get; set; }
      public ContractOrContractReference after { get; set; }
   }
   class ExerciseFeeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseFeeBuilder";
      public string notionalReference { get; set; }
      public float feeAmount { get; set; }
      public float feeRate { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   class ExerciseFee : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExerciseFee";
      public string notionalReference { get; set; }
      public RelativeDateOffset feePaymentDate { get; set; }
      public float feeAmount { get; set; }
      public float feeRate { get; set; }
      public string sellerPartyReference { get; set; }
      public string buyerPartyReference { get; set; }
      public string buyerAccountReference { get; set; }
      public string sellerAccountReference { get; set; }
   }
   enum BusinessDayConventionEnum {
      FOLLOWING,
      FRN,
      MODFOLLOWING,
      PRECEDING,
      MODPRECEDING,
      NEAREST,
      NONE,
      NOT_APPLICABLE,
   }

   class CancelableProvisionAdjustedDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancelableProvisionAdjustedDatesBuilder";
   }
   class CancelableProvisionAdjustedDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CancelableProvisionAdjustedDates";
      public CancellationEvent[] cancellationEvent { get; set; }
   }
   enum PremiumTypeEnum {
      PRE_PAID,
      POST_PAID,
      VARIABLE,
      FIXED,
   }

   class Quantity : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Quantity";
      public UnitEnum unit { get; set; }
      public float amount { get; set; }
   }
   class QuantityBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuantityBuilder";
      public UnitEnum unit { get; set; }
      public float amount { get; set; }
   }
   class FinalCalculationPeriodDateAdjustment : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FinalCalculationPeriodDateAdjustment";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string relevantUnderlyingDateReference { get; set; }
      public string swapStreamReference { get; set; }
   }
   class FinalCalculationPeriodDateAdjustmentBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FinalCalculationPeriodDateAdjustmentBuilder";
      public BusinessDayConventionEnum businessDayConvention { get; set; }
      public string relevantUnderlyingDateReference { get; set; }
      public string swapStreamReference { get; set; }
   }
   class CalculationAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAmount";
      public Step[] step { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   class CalculationAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CalculationAmountBuilder";
      public string id { get; set; }
      public string currency { get; set; }
      public string currencyScheme { get; set; }
      public float amount { get; set; }
   }
   enum TriggerTimeTypeEnum {
      CLOSING,
      ANYTIME,
   }

   class EarlyTerminationProvision : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EarlyTerminationProvision";
      public string id { get; set; }
      public Period mandatoryEarlyTerminationDateTenor { get; set; }
      public ExercisePeriod optionalEarlyTerminationParameters { get; set; }
      public MandatoryEarlyTermination mandatoryEarlyTermination { get; set; }
      public OptionalEarlyTermination optionalEarlyTermination { get; set; }
   }
   class EarlyTerminationProvisionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.EarlyTerminationProvisionBuilder";
      public string id { get; set; }
   }
   class PremiumExpression : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PremiumExpression";
      public PremiumTypeEnum premiumType { get; set; }
      public Money pricePerOption { get; set; }
      public float percentageOfNotional { get; set; }
   }
   class PremiumExpressionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PremiumExpressionBuilder";
      public PremiumTypeEnum premiumType { get; set; }
      public float percentageOfNotional { get; set; }
   }
   class FxFeatureBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxFeatureBuilder";
      public string referenceCurrency { get; set; }
      public string referenceCurrencyScheme { get; set; }
   }
   class FxFeature : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.FxFeature";
      public string referenceCurrency { get; set; }
      public Composite composite { get; set; }
      public Quanto quanto { get; set; }
      public Composite crossCurrency { get; set; }
      public string referenceCurrencyScheme { get; set; }
   }
   enum WeeklyRollConventionEnum {
      TBILL,
      MON,
      TUE,
      WED,
      THU,
      FRI,
      SAT,
      SUN,
   }

   class Rosetta : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Rosetta";
   }
   class IdentifiedAssetBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IdentifiedAssetBuilder";
      public string id { get; set; }
      public string instrumentIdentifierScheme { get; set; }
      public string description { get; set; }
      public string[] instrumentIdentifier { get; set; }
   }
   class IdentifiedAsset : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.IdentifiedAsset";
      public string id { get; set; }
      public string instrumentIdentifierScheme { get; set; }
      public string description { get; set; }
      public string[] instrumentIdentifier { get; set; }
   }
   class CrossCurrencyMethodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CrossCurrencyMethodBuilder";
      public string cashSettlementCurrencyScheme { get; set; }
      public string[] cashSettlementCurrency { get; set; }
      public QuotationRateTypeEnum quotationRateType { get; set; }
   }
   class CrossCurrencyMethod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CrossCurrencyMethod";
      public string cashSettlementCurrencyScheme { get; set; }
      public CashSettlementReferenceBanks[] cashSettlementReferenceBanks { get; set; }
      public string[] cashSettlementCurrency { get; set; }
      public QuotationRateTypeEnum quotationRateType { get; set; }
   }
   class ContractReferenceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractReferenceBuilder";
      public StateEnum state { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   class ContractReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ContractReference";
      public StateEnum state { get; set; }
      public string rosettaKey { get; set; }
      public string accountReference { get; set; }
      public string partyReference { get; set; }
      public IdentifierValue identifierValue { get; set; }
      public string issuer { get; set; }
      public string issuerScheme { get; set; }
      public int version { get; set; }
   }
   enum RestructuringEnum {
      MOD_MOD_R,
      MOD_R,
      R,
   }

   class OptionFeatureBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionFeatureBuilder";
   }
   class OptionFeature : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionFeature";
      public FxFeature fxFeature { get; set; }
      public StrategyFeature strategyFeature { get; set; }
      public Asian asian { get; set; }
      public Barrier barrier { get; set; }
      public Knock knock { get; set; }
      public PassThrough passThrough { get; set; }
   }
   class LegalEntityBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LegalEntityBuilder";
      public string name { get; set; }
      public string id { get; set; }
      public string entityId { get; set; }
      public string entityIdScheme { get; set; }
      public string nameScheme { get; set; }
   }
   class LegalEntity : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.LegalEntity";
      public string name { get; set; }
      public string id { get; set; }
      public string entityId { get; set; }
      public string entityIdScheme { get; set; }
      public string nameScheme { get; set; }
   }
   enum StateEnum {
      ALLOCATED,
      EXERCISED,
      NOVATED,
      TERMINATED,
   }

   class MasterConfirmation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MasterConfirmation";
      public MasterConfirmationTypeEnum masterConfirmationType { get; set; }
      public DateTime masterConfirmationDate { get; set; }
      public DateTime masterConfirmationAnnexDate { get; set; }
      public MasterConfirmationAnnexTypeEnum masterConfirmationAnnexType { get; set; }
      public string masterConfirmationAnnexTypeScheme { get; set; }
      public string masterConfirmationTypeScheme { get; set; }
   }
   class MasterConfirmationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MasterConfirmationBuilder";
      public MasterConfirmationTypeEnum masterConfirmationType { get; set; }
      public DateTime masterConfirmationDate { get; set; }
      public DateTime masterConfirmationAnnexDate { get; set; }
      public MasterConfirmationAnnexTypeEnum masterConfirmationAnnexType { get; set; }
      public string masterConfirmationAnnexTypeScheme { get; set; }
      public string masterConfirmationTypeScheme { get; set; }
   }
   class Commodity : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Commodity";
   }
   class CommodityBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CommodityBuilder";
   }
   class BusinessCenterTime : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessCenterTime";
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum businessCenter { get; set; }
      public DateTime hourMinuteTime { get; set; }
   }
   class BusinessCenterTimeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BusinessCenterTimeBuilder";
      public string businessCenterScheme { get; set; }
      public BusinessCenterEnum businessCenter { get; set; }
      public DateTime hourMinuteTime { get; set; }
   }
   enum NegativeInterestRateTreatmentEnum {
      NEGATIVE_INTEREST_RATE_METHOD,
      ZERO_INTEREST_RATE_METHOD,
   }

   class GracePeriodExtensionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GracePeriodExtensionBuilder";
      public bool applicable { get; set; }
   }
   class GracePeriodExtension : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.GracePeriodExtension";
      public bool applicable { get; set; }
      public Offset gracePeriod { get; set; }
   }
   class PrincipalExchangesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrincipalExchangesBuilder";
      public string id { get; set; }
      public bool initialExchange { get; set; }
      public bool finalExchange { get; set; }
      public bool intermediateExchange { get; set; }
   }
   class PrincipalExchanges : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrincipalExchanges";
      public string id { get; set; }
      public bool initialExchange { get; set; }
      public bool finalExchange { get; set; }
      public bool intermediateExchange { get; set; }
   }
   enum RateTreatmentEnum {
      BOND_EQUIVALENT_YIELD,
      MONEY_MARKET_YIELD,
   }

   class Bond : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Bond";
      public Period paymentFrequency { get; set; }
      public string dayCountFractionScheme { get; set; }
      public float parValue { get; set; }
      public float issuanceFaceAmount { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class BondBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BondBuilder";
      public string dayCountFractionScheme { get; set; }
      public float parValue { get; set; }
      public float issuanceFaceAmount { get; set; }
      public DayCountFractionEnum dayCountFraction { get; set; }
      public string couponTypeScheme { get; set; }
      public string seniorityScheme { get; set; }
      public string issuerName { get; set; }
      public string issuerReference { get; set; }
      public CreditSeniorityEnum seniority { get; set; }
      public CouponTypeEnum couponType { get; set; }
      public float couponRate { get; set; }
      public DateTime maturity { get; set; }
      public DateTime issueDate { get; set; }
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   enum MatrixTermEnum {
      IVS_1_OPEN_MARKETS,
   }

   enum AveragingInOutEnum {
      IN,
      OUT,
      BOTH,
   }

   class PrincipalExchange : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrincipalExchange";
      public string id { get; set; }
      public float discountFactor { get; set; }
      public DateTime unadjustedPrincipalExchangeDate { get; set; }
      public DateTime adjustedPrincipalExchangeDate { get; set; }
      public float principalExchangeAmount { get; set; }
      public Money presentValuePrincipalExchangeAmount { get; set; }
   }
   class PrincipalExchangeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PrincipalExchangeBuilder";
      public string id { get; set; }
      public float discountFactor { get; set; }
      public DateTime unadjustedPrincipalExchangeDate { get; set; }
      public DateTime adjustedPrincipalExchangeDate { get; set; }
      public float principalExchangeAmount { get; set; }
   }
   class ReferencePair : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePair";
      public ReferenceObligation referenceObligation { get; set; }
      public LegalEntity referenceEntity { get; set; }
      public bool noReferenceObligation { get; set; }
      public EntityTypeEnum entityType { get; set; }
      public string entityTypeScheme { get; set; }
   }
   class ReferencePairBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferencePairBuilder";
      public bool noReferenceObligation { get; set; }
      public EntityTypeEnum entityType { get; set; }
      public string entityTypeScheme { get; set; }
   }
   enum SettlementRateOptionEnum {
      ARS_BNAR_ARS01,
      ARS_EMTA_INDICATIVE_SURVEY_RATE_ARS04,
      BRL_PTAX_BRL09,
      CNY_SAEC_CNY01,
      KRW_KFTC18_KRW02,
      INR_RBIB_INR01,
   }

   class TermsChangePrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TermsChangePrimitive";
      public ContractOrContractReference before { get; set; }
      public ContractOrContractReference after { get; set; }
   }
   class TermsChangePrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.TermsChangePrimitiveBuilder";
   }
   class Rounding : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Rounding";
      public RoundingDirectionEnum roundingDirection { get; set; }
      public int precision { get; set; }
   }
   class RoundingBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RoundingBuilder";
      public RoundingDirectionEnum roundingDirection { get; set; }
      public int precision { get; set; }
   }
   class ProductIdentificationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductIdentificationBuilder";
      public string productQualifier { get; set; }
      public AssetClassEnum primaryAssetClass { get; set; }
      public AssetClassEnum[] secondaryAssetClass { get; set; }
      public string[] productType { get; set; }
      public string[] productId { get; set; }
      public string productIdScheme { get; set; }
      public string primaryAssetClassScheme { get; set; }
      public string productTypeScheme { get; set; }
      public string secondaryAssetClassScheme { get; set; }
   }
   class ProductIdentification : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ProductIdentification";
      public string productQualifier { get; set; }
      public AssetClassEnum primaryAssetClass { get; set; }
      public AssetClassEnum[] secondaryAssetClass { get; set; }
      public string[] productType { get; set; }
      public string[] productId { get; set; }
      public string productIdScheme { get; set; }
      public string primaryAssetClassScheme { get; set; }
      public string productTypeScheme { get; set; }
      public string secondaryAssetClassScheme { get; set; }
   }
   class AveragingSchedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingSchedule";
      public DateTime endDate { get; set; }
      public DateTime startDate { get; set; }
      public CalculationPeriodFrequency averagingPeriodFrequency { get; set; }
   }
   class AveragingScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingScheduleBuilder";
      public DateTime endDate { get; set; }
      public DateTime startDate { get; set; }
   }
   class DateTimeListBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateTimeListBuilder";
      public DateTime[] dateTime { get; set; }
   }
   class DateTimeList : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateTimeList";
      public DateTime[] dateTime { get; set; }
   }
   class MakeWholeAmountBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MakeWholeAmountBuilder";
      public InterpolationMethodEnum interpolationMethod { get; set; }
      public DateTime earlyCallDate { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public float spread { get; set; }
      public QuotationSideEnum side { get; set; }
   }
   class MakeWholeAmount : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MakeWholeAmount";
      public InterpolationMethodEnum interpolationMethod { get; set; }
      public DateTime earlyCallDate { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public float spread { get; set; }
      public QuotationSideEnum side { get; set; }
   }
   class BondReferenceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BondReferenceBuilder";
      public bool conditionPrecedentBond { get; set; }
      public bool discrepancyClause { get; set; }
   }
   class BondReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.BondReference";
      public Bond bond { get; set; }
      public bool conditionPrecedentBond { get; set; }
      public bool discrepancyClause { get; set; }
   }
   class ValuationPostponement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ValuationPostponement";
      public int maximumDaysOfPostponement { get; set; }
   }
   class ValuationPostponementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ValuationPostponementBuilder";
      public int maximumDaysOfPostponement { get; set; }
   }
   class SettlementProvision : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettlementProvision";
      public string settlementCurrency { get; set; }
      public NonDeliverableSettlement nonDeliverableSettlement { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class SettlementProvisionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.SettlementProvisionBuilder";
      public string settlementCurrency { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class CashflowBaseBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashflowBaseBuilder";
      public string id { get; set; }
      public float discountFactor { get; set; }
   }
   class CashflowBase : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashflowBase";
      public string id { get; set; }
      public float discountFactor { get; set; }
      public Money presentValueAmount { get; set; }
      public PremiumExpression premiumExpression { get; set; }
      public PaymentDiscounting paymentDiscounting { get; set; }
      public PayerReceiver payerReceiver { get; set; }
   }
   class Resource : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Resource";
      public ResourceLength length { get; set; }
      public string name { get; set; }
      public string language { get; set; }
      public string resourceId { get; set; }
      public ResourceTypeEnum resourceType { get; set; }
      public float sizeInBytes { get; set; }
      public string mimeType { get; set; }
      public string comments { get; set; }
      public string url { get; set; }
      public string string { get; set; }
      public string languageScheme { get; set; }
      public string mimeTypeScheme { get; set; }
      public string resourceIdScheme { get; set; }
      public string resourceTypeScheme { get; set; }
   }
   class ResourceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ResourceBuilder";
      public string name { get; set; }
      public string language { get; set; }
      public string resourceId { get; set; }
      public ResourceTypeEnum resourceType { get; set; }
      public float sizeInBytes { get; set; }
      public string mimeType { get; set; }
      public string comments { get; set; }
      public string url { get; set; }
      public string string { get; set; }
      public string languageScheme { get; set; }
      public string mimeTypeScheme { get; set; }
      public string resourceIdScheme { get; set; }
      public string resourceTypeScheme { get; set; }
   }
   class ReferenceObligationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceObligationBuilder";
      public string primaryObligorReference { get; set; }
      public string guarantorReference { get; set; }
      public bool standardReferenceObligation { get; set; }
   }
   class ReferenceObligation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ReferenceObligation";
      public Mortgage mortgage { get; set; }
      public Bond bond { get; set; }
      public ConvertibleBond convertibleBond { get; set; }
      public Loan loan { get; set; }
      public LegalEntity primaryObligor { get; set; }
      public string primaryObligorReference { get; set; }
      public LegalEntity guarantor { get; set; }
      public string guarantorReference { get; set; }
      public bool standardReferenceObligation { get; set; }
   }
   enum ValuationMethodEnum {
      MARKET,
      HIGHEST,
      AVERAGE_MARKET,
      AVERAGE_HIGHEST,
      BLENDED_MARKET,
      BLENDED_HIGHEST,
      AVERAGE_BLENDED_MARKET,
      AVERAGE_BLENDED_HIGHEST,
   }

   class ExecutionBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExecutionBuilder";
   }
   class Execution : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Execution";
      public TradeHeader tradeHeader { get; set; }
      public ContractualProduct contractualProduct { get; set; }
      public Party[] party { get; set; }
   }
   class InformationSource : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InformationSource";
      public InformationProviderEnum sourceProvider { get; set; }
      public string sourcePage { get; set; }
      public string sourcePageHeading { get; set; }
      public string sourcePageScheme { get; set; }
      public string sourceProviderScheme { get; set; }
   }
   class InformationSourceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InformationSourceBuilder";
      public InformationProviderEnum sourceProvider { get; set; }
      public string sourcePage { get; set; }
      public string sourcePageHeading { get; set; }
      public string sourcePageScheme { get; set; }
      public string sourceProviderScheme { get; set; }
   }
   class MandatoryEarlyTerminationAdjustedDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MandatoryEarlyTerminationAdjustedDates";
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
   }
   class MandatoryEarlyTerminationAdjustedDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MandatoryEarlyTerminationAdjustedDatesBuilder";
      public DateTime adjustedEarlyTerminationDate { get; set; }
      public DateTime adjustedCashSettlementValuationDate { get; set; }
      public DateTime adjustedCashSettlementPaymentDate { get; set; }
   }
   class InitialFixingDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InitialFixingDateBuilder";
      public DateTime initialFixingDate { get; set; }
   }
   class Period : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Period";
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class InitialFixingDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InitialFixingDate";
      public DateTime initialFixingDate { get; set; }
      public RelativeDateOffset relativeDateOffset { get; set; }
   }
   class OptionCashSettlement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionCashSettlement";
      public string id { get; set; }
      public CashSettlementPaymentDate cashSettlementPaymentDate { get; set; }
      public BusinessCenterTime cashSettlementValuationTime { get; set; }
      public RelativeDateOffset cashSettlementValuationDate { get; set; }
      public CashPriceMethod cashPriceMethod { get; set; }
      public CashPriceMethod cashPriceAlternateMethod { get; set; }
      public YieldCurveMethod parYieldCurveAdjustedMethod { get; set; }
      public YieldCurveMethod zeroCouponYieldAdjustedMethod { get; set; }
      public YieldCurveMethod parYieldCurveUnadjustedMethod { get; set; }
      public CrossCurrencyMethod crossCurrencyMethod { get; set; }
      public YieldCurveMethod collateralizedCashPriceMethod { get; set; }
   }
   class OptionCashSettlementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionCashSettlementBuilder";
      public string id { get; set; }
   }
   class NotionalStepRuleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotionalStepRuleBuilder";
      public float notionalStepAmount { get; set; }
      public float notionalStepRate { get; set; }
      public StepRelativeToEnum stepRelativeTo { get; set; }
      public DateTime firstNotionalStepDate { get; set; }
      public DateTime lastNotionalStepDate { get; set; }
      public string calculationPeriodDatesReference { get; set; }
   }
   class NotionalStepRule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.NotionalStepRule";
      public float notionalStepAmount { get; set; }
      public float notionalStepRate { get; set; }
      public StepRelativeToEnum stepRelativeTo { get; set; }
      public Frequency stepFrequency { get; set; }
      public DateTime firstNotionalStepDate { get; set; }
      public DateTime lastNotionalStepDate { get; set; }
      public string calculationPeriodDatesReference { get; set; }
   }
   class InflationRateCalculation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InflationRateCalculation";
      public Offset inflationLag { get; set; }
      public string indexSource { get; set; }
      public string mainPublication { get; set; }
      public InterpolationMethodEnum interpolationMethod { get; set; }
      public float initialIndexLevel { get; set; }
      public bool fallbackBondApplicable { get; set; }
      public string indexSourceScheme { get; set; }
      public string interpolationMethodScheme { get; set; }
      public string mainPublicationScheme { get; set; }
      public float initialRate { get; set; }
      public Rounding finalRateRounding { get; set; }
      public AveragingMethodEnum averagingMethod { get; set; }
      public NegativeInterestRateTreatmentEnum negativeInterestRateTreatment { get; set; }
      public string id { get; set; }
      public SpreadSchedule[] spreadSchedule { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public Schedule floatingRateMultiplierSchedule { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
      public StrikeSchedule[] capRateSchedule { get; set; }
      public StrikeSchedule[] floorRateSchedule { get; set; }
   }
   class InflationRateCalculationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.InflationRateCalculationBuilder";
      public string indexSource { get; set; }
      public string mainPublication { get; set; }
      public InterpolationMethodEnum interpolationMethod { get; set; }
      public float initialIndexLevel { get; set; }
      public bool fallbackBondApplicable { get; set; }
      public string indexSourceScheme { get; set; }
      public string interpolationMethodScheme { get; set; }
      public string mainPublicationScheme { get; set; }
      public float initialRate { get; set; }
      public AveragingMethodEnum averagingMethod { get; set; }
      public NegativeInterestRateTreatmentEnum negativeInterestRateTreatment { get; set; }
      public string id { get; set; }
      public string floatingRateIndexScheme { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
   }
   class QuantityChangePrimitiveBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuantityChangePrimitiveBuilder";
   }
   class QuantityChangePrimitive : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.QuantityChangePrimitive";
      public ContractOrContractReference before { get; set; }
      public ContractualQuantity[] change { get; set; }
      public ContractOrContractReference after { get; set; }
   }
   class Documentation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Documentation";
      public ContractualDefinitionsEnum[] contractualDefinitions { get; set; }
      public ContractualTermsSupplement[] contractualTermsSupplement { get; set; }
      public MasterAgreement masterAgreement { get; set; }
      public BrokerConfirmation brokerConfirmation { get; set; }
      public CreditSupportAgreement creditSupportAgreement { get; set; }
      public OtherAgreement[] otherAgreement { get; set; }
      public Resource[] attachment { get; set; }
      public MasterConfirmation masterConfirmation { get; set; }
      public ContractualMatrix[] contractualMatrix { get; set; }
      public string contractualDefinitionsScheme { get; set; }
   }
   class DocumentationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DocumentationBuilder";
      public ContractualDefinitionsEnum[] contractualDefinitions { get; set; }
      public string contractualDefinitionsScheme { get; set; }
   }
   enum CompoundingMethodEnum {
      FLAT,
      NONE,
      STRAIGHT,
      SPREAD_EXCLUSIVE,
   }

   class ExercisePeriod : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExercisePeriod";
      public string id { get; set; }
      public Period earliestExerciseDateTenor { get; set; }
      public Period exerciseFrequency { get; set; }
   }
   class ExercisePeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ExercisePeriodBuilder";
      public string id { get; set; }
   }
   class AdjustableDate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableDate";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public string dateAdjustmentsReference { get; set; }
      public DateTime adjustedDate { get; set; }
      public BusinessDayAdjustments dateAdjustments { get; set; }
   }
   class AdjustableDateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AdjustableDateBuilder";
      public string id { get; set; }
      public DateTime unadjustedDate { get; set; }
      public string dateAdjustmentsReference { get; set; }
      public DateTime adjustedDate { get; set; }
   }
   class StubFloatingRate : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubFloatingRate";
      public string id { get; set; }
      public SpreadSchedule[] spreadSchedule { get; set; }
      public Schedule floatingRateMultiplierSchedule { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public Period indexTenor { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
      public StrikeSchedule[] capRateSchedule { get; set; }
      public StrikeSchedule[] floorRateSchedule { get; set; }
   }
   class StubFloatingRateBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.StubFloatingRateBuilder";
      public string id { get; set; }
      public FloatingRateIndexEnum floatingRateIndex { get; set; }
      public RateTreatmentEnum rateTreatment { get; set; }
   }
   enum DayCountFractionEnum {
      _1_1,
      _30_360,
      _30E_360,
      _30E_360_ISDA,
      ACT_360,
      ACT_365_FIXED,
      ACT_365L,
      ACT_ACT_AFB,
      ACT_ACT_ICMA,
      ACT_ACT_ISDA,
      ACT_ACT_ISMA,
      BUS_252,
   }

   class PriorDateInstanceBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PriorDateInstanceBuilder";
      public DateTime date { get; set; }
   }
   class PriorDateInstance : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PriorDateInstance";
      public Identifier contractReference { get; set; }
      public DateTime date { get; set; }
   }
   class DateRelativeToCalculationPeriodDates : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRelativeToCalculationPeriodDates";
      public string[] calculationPeriodDatesReference { get; set; }
   }
   class DateRelativeToCalculationPeriodDatesBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.DateRelativeToCalculationPeriodDatesBuilder";
      public string[] calculationPeriodDatesReference { get; set; }
   }
   enum NaturalPersonRoleEnum {
      TRADER,
   }

   class CompositeBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CompositeBuilder";
      public DeterminationMethodEnum determinationMethod { get; set; }
   }
   class Composite : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Composite";
      public FxSpotRateSource fxSpotRateSource { get; set; }
      public DeterminationMethodEnum determinationMethod { get; set; }
      public RelativeDateOffset relativeDate { get; set; }
   }
   class AveragingObservationListBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingObservationListBuilder";
   }
   class AveragingObservationList : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.AveragingObservationList";
      public WeightedAveragingObservation[] averagingObservation { get; set; }
   }
   enum TransferStatusEnum {
      DISPUTED,
      INSTRUCTED,
      PENDING,
      SETTLED,
   }

   class ListedHeader : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ListedHeader";
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public ProductIdentifier[] productIdentifier { get; set; }
      public ProductTaxonomy[] productTaxonomy { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class ListedHeaderBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ListedHeaderBuilder";
      public string id { get; set; }
      public string currency { get; set; }
      public string clearanceSystemScheme { get; set; }
      public string productIdentifierScheme { get; set; }
      public string description { get; set; }
      public string clearanceSystem { get; set; }
      public string currencyScheme { get; set; }
   }
   class OptionPhysicalSettlementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionPhysicalSettlementBuilder";
      public bool clearedPhysicalSettlement { get; set; }
      public string predeterminedClearingOrganizationPartyReference { get; set; }
   }
   class OptionPhysicalSettlement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionPhysicalSettlement";
      public bool clearedPhysicalSettlement { get; set; }
      public string predeterminedClearingOrganizationPartyReference { get; set; }
   }
   class PackageInformation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PackageInformation";
      public CategoryEnum[] category { get; set; }
      public RelatedParty[] relatedParty { get; set; }
      public bool intentToAllocate { get; set; }
   }
   class PackageInformationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PackageInformationBuilder";
      public CategoryEnum[] category { get; set; }
      public bool intentToAllocate { get; set; }
   }
   class Cashflow : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Cashflow";
      public AdjustableOrAdjustedOrRelativeDate cashflowDate { get; set; }
      public string rosettaKeyValue { get; set; }
      public string cashflowCalculation { get; set; }
      public CashflowTypeEnum cashflowType { get; set; }
      public Money cashflowAmount { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
      public Money presentValueAmount { get; set; }
      public PremiumExpression premiumExpression { get; set; }
      public PaymentDiscounting paymentDiscounting { get; set; }
      public PayerReceiver payerReceiver { get; set; }
   }
   class CashflowBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashflowBuilder";
      public string cashflowCalculation { get; set; }
      public CashflowTypeEnum cashflowType { get; set; }
      public string id { get; set; }
      public float discountFactor { get; set; }
   }
   enum CommodityReferencePriceEnum {
      ALUMINIUM_ALLOY_LME_15_MONTH,
   }

   class PeriodBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.PeriodBuilder";
      public string id { get; set; }
      public PeriodEnum period { get; set; }
      public int periodMultiplier { get; set; }
   }
   class CashSettlementTerms : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementTerms";
      public string id { get; set; }
      public Money quotationAmount { get; set; }
      public Money minimumQuotationAmout { get; set; }
      public bool accruedInterest { get; set; }
      public string settlementCurrency { get; set; }
      public int cashSettlementBusinessDays { get; set; }
      public ValuationDate valuationDate { get; set; }
      public BusinessCenterTime valuationTime { get; set; }
      public QuotationRateTypeEnum quotationMethod { get; set; }
      public string dealer { get; set; }
      public Money cashSettlementAmount { get; set; }
      public bool fixedSettlement { get; set; }
      public ValuationMethodEnum valuationMethod { get; set; }
      public float recoveryFactor { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class CashSettlementTermsBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.CashSettlementTermsBuilder";
      public string id { get; set; }
      public bool accruedInterest { get; set; }
      public string settlementCurrency { get; set; }
      public int cashSettlementBusinessDays { get; set; }
      public QuotationRateTypeEnum quotationMethod { get; set; }
      public string dealer { get; set; }
      public bool fixedSettlement { get; set; }
      public ValuationMethodEnum valuationMethod { get; set; }
      public float recoveryFactor { get; set; }
      public string settlementCurrencyScheme { get; set; }
   }
   class RateObservationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RateObservationBuilder";
      public string id { get; set; }
      public int observationWeight { get; set; }
      public DateTime resetDate { get; set; }
      public DateTime adjustedFixingDate { get; set; }
      public float observedRate { get; set; }
      public float treatedRate { get; set; }
      public string rateReference { get; set; }
      public float forecastRate { get; set; }
      public float treatedForecastRate { get; set; }
   }
   class RateObservation : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.RateObservation";
      public string id { get; set; }
      public int observationWeight { get; set; }
      public DateTime resetDate { get; set; }
      public DateTime adjustedFixingDate { get; set; }
      public float observedRate { get; set; }
      public float treatedRate { get; set; }
      public string rateReference { get; set; }
      public float forecastRate { get; set; }
      public float treatedForecastRate { get; set; }
   }
   class MasterAgreement : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MasterAgreement";
      public string masterAgreementId { get; set; }
      public MasterAgreementTypeEnum masterAgreementType { get; set; }
      public string masterAgreementVersion { get; set; }
      public DateTime masterAgreementDate { get; set; }
      public string masterAgreementIdScheme { get; set; }
      public string masterAgreementTypeScheme { get; set; }
      public string masterAgreementVersionScheme { get; set; }
   }
   class MasterAgreementBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.MasterAgreementBuilder";
      public string masterAgreementId { get; set; }
      public MasterAgreementTypeEnum masterAgreementType { get; set; }
      public string masterAgreementVersion { get; set; }
      public DateTime masterAgreementDate { get; set; }
      public string masterAgreementIdScheme { get; set; }
      public string masterAgreementTypeScheme { get; set; }
      public string masterAgreementVersionScheme { get; set; }
   }
   class ScheduleBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.ScheduleBuilder";
      public string id { get; set; }
      public float initialValue { get; set; }
   }
   class Schedule : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.Schedule";
      public string id { get; set; }
      public float initialValue { get; set; }
      public Step[] step { get; set; }
   }
   class OptionDenomination : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionDenomination";
      public float optionEntitlement { get; set; }
      public float numberOfOptions { get; set; }
      public string entitlementCurrency { get; set; }
      public string entitlementCurrencyScheme { get; set; }
   }
   class OptionDenominationBuilder : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.isda.cdm.OptionDenominationBuilder";
      public float optionEntitlement { get; set; }
      public float numberOfOptions { get; set; }
      public string entitlementCurrency { get; set; }
      public string entitlementCurrencyScheme { get; set; }
   }
}
